/****************************************************************************
 *
 * rg/pkg/build/config_opt.c
 * 
 * Copyright (C) Jungo LTD 2004
 * 
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

#include <stdlib.h>
#include "config_opt.h"

option_t openrg_hw_options[] = {
    { "WADB100G", "BCM6348" },
    { "MPC8272ADS", "FreeScale mpc8272ads" },
    { "ALLWELL_RTL_RTL", "Allwell" },
    { "ALLWELL_RTL_RTL_ISL38XX", "Allwell" },
    { "ALLWELL_RTL_EEP", "Allwell 1030N" },
    { "ALLWELL_ATMNULL_RTL", "Allwell" },
    { "PCBOX_EEP_EEP", "Generic PCBOX" },
    { "CX82100", "Conexant CX82100" },
    { "TI_404", "TNETC440" },
    { "AR531X_G", "Atheros AR531x" },
    { "AR531X_AG", "Atheros AR531x A+G" },
    { "AR531X_WRT55AG", "Gemtek WRT55AG Atheros AR531X" },
    { "WRT108G", "WRT108G" },
    { "TI_TNETWA100", "TI TNETWA100 AP VX" },
    { "I386_BOCHS", "Jungo i386" },
    /* XScale IXP425 Based devices */
    { "IXDP425", "IXDP425" },
    { "IXDP425_TMT", "IXDP425" },
    { "MATECUMBE", "Matecumbe" },
    { "COYOTE_ATM_WIRELESS", "Coyote" },
    { "COYOTE_WIRELESS", "Coyote" },
    { "COYOTE", "Coyote" },
    { "KINGSCANYON", "Kings Canyon" },
    { "ROCKAWAYBEACH", "Rockaway Beach" },
    { "HG21", "HG21" },
    { "NAPA", "Napa" },
    { "BAMBOO", "Bamboo" },
    { "BCM94702", "Broadcom 94702" },
    { "BCM94704", "Broadcom 94704" },
    { "BCM94712", "Broadcom 94712" },
    { "RTA770W", "Belkin RTA770W" },
    { "GTWX5803", "Gemtek GTWX5803" },
    { "RTA770W_RGLOADER", "Belkin RTA770W RGLoader" },
    { "WRT54G", "Cybertan WRT54G" },
    { "USR8200", "US Robotics USR8200" },
    { "GTWX5715", "Gemtek WX5715" },
    { "WAV54G", "Cybertan WAV54G" },
    { "INCAIP", "Infineon INCA-IP" },
    { "INCAIP_LSP", "Infineon INCA-IP LSP" },
    { "INCAIP_RGLOADER", "RGLoader for Infineon INCA-IP" },
    { "ALLTEK", "Alltek INCA-IP ATA" },
    { "FLEXTRONICS", "Infineon Flextronics" },
    { "ALLTEK_VLAN", "Alltek INCA-IP IAD" },
    { "ALLTEK_RGLOADER", "RGLoader for Infineon INCA-IP ATA/IAD" },
    { "ADM5120P", "ADMTek 5120P" },
    { "CX8620XR", "Conexant CX8620X Reference Board" },
    { "CX8620XD", "Conexant CX8620X Development Board" },
    { "CENTROID", "Storlink Centroid" },
    { "MONTEJADE", "Monte Jade" },
    { "BRUCE", "Jabil Bruce" },
    { "MI424WR", "MI424-WR" },
    { "MI524WR", "MI524WR" },
    { "VI414WG", "VI414-WG" },
    { "VI414WG_ETH", "VI414-WG with WAN Ethernet port" },
    { "KI414WG", "KI414-WG" },
    { "KI414WG_ETH", "KI414-WG with WAN Ethernet port" },
    { "BA214WG", "BA214-WG" },
    { "RI408", "RI408" },
    { "CENTAUR", "MICREL CENTAUR KS8695PX" },
    { "UML", "UML" },
    { "JPKG", "JPKG" },
    { NULL, NULL },
};

option_t openrg_os_options[] = {
    { "LINUX_22", NULL },
    { "LINUX_24", NULL },
    { "ECOS", NULL },
    { "VXWORKS", NULL },
    { NULL, NULL },
};

option_t openrg_distribution_options[] = {
    /* MIPS */
    { "INCAIP_LSP", NULL },
    { "INCAIP", NULL },
    { "INCAIP_IPPHONE", NULL },
    { "INCAIP_ATA", NULL },
    { "INCAIP_ATA_OSIP", NULL },
    { "INCAIP_VGW", NULL }, /* ATA + OpenRG advanced functionality */
    { "INCAIP_VGW_OSIP", NULL },
    { "INCAIP_FULLSOURCE", NULL }, /* OpenRG advanced functionality NO VOIP! */
    { "FLEXTRONICS_IPPHONE", NULL },
    { "ADM5120_LSP", NULL },
    { "RGLOADER_ADM5120", NULL },
    { "ADM5120_VGW", NULL },
    { "ADM5120_VGW_OSIP", NULL },
    { "ADM5120_ATA", NULL },
    { "BCM94702", NULL },
    { "BCM94704", NULL },
    { "USI_BCM94712", NULL },
    { "SRI_USI_BCM94712", NULL },
    { "RTA770W", NULL },
    { "RTA770W_EVAL", NULL },
    { "RGLOADER_RTA770W", NULL },
    { "GTWX5803", NULL },
    { "GTWX5803_EVAL", NULL },
    { "RGLOADER_GTWX5803", NULL },
    { "WRT54G", NULL },

    /* X86: Not a real distribution but easy to use: HW==DIST and define a
     * full openrg (ORG)
     */ 
    { "ALLWELL_RTL_RTL", NULL },
    { "ALLWELL_RTL_RTL_SSI", NULL },
    { "ALLWELL_RTL_RTL_ISL38XX", NULL },
    { "ALLWELL_RTL_RTL_ALADDIN", NULL },
    { "ALLWELL_RTL_RTL_WELLTECH", NULL }, /* Note: openrg and WBM as full 
					   * src.
					   */
    { "ALLWELL_RTL_EEP", NULL },
    { "ALLWELL_ATMNULL_RTL", NULL },
    { "PCBOX_EEP_EEP", NULL },
    { "PCBOX_EEP_EEP_EICON", NULL },
    { "PCBOX_RTL_RTL_EICON", NULL },
    { "X86_FRG_TMT", NULL },

    { "CX82100_SCHMID", NULL },
    /* Storlink based distributions */
    { "CENTROID", NULL },
    { "RGLOADER_CENTROID", NULL },
    /* XScale IXP425 based distributions
     * Several are simple HW==DIST, but some are real
     */
    { "IXDP425", NULL },
    { "IXDP425_WIRELESS", NULL },
    { "IXDP425_ATM_WIRELESS", NULL },
    { "IXDP425_FULLSOURCE", NULL },
    { "IXDP425_NETKLASS", NULL },
    { "IXDP425_VPN", NULL },
    { "IXDP425_FRG", NULL },
    { "IXDP425_TMT", NULL },
    { "WADB100G", NULL },
    { "WADB100G_RGLOADER", "BCM6348 RGLOADER" },
    { "MPC8272ADS_LSP", NULL },
    { "MPC8272ADS_EEPRO1000", NULL },
    { "MPC8272ADS", NULL },
    { "MPC8272ADS_JPC", NULL },
    { "IXDP425_LSP", NULL },
    { "IXDP425_ATM", NULL },
    { "COYOTE_CAVIUM", NULL },
    { "IXDP425_CAVIUM", NULL },
    { "IXDP425_GST", NULL },
    { "MATECUMBE", NULL },
    { "COYOTE", NULL },
    { "COYOTE_ACTIONTEC_OSIP", NULL },
    { "KINGSCANYON", NULL },
    { "RGLOADER_KINGSCANYON_LSP", NULL },
    { "KINGSCANYON_LSP", NULL },
    { "KINGSCANYON_WIRELESS", NULL },
    { "ROCKAWAYBEACH", NULL },
    { "ROCKAWAYBEACH_WIRELESS", NULL },
    { "HG21", NULL },
    { "COYOTE_LSP", NULL },
    { "COYOTE_WIRELESS_80211B", NULL },
    { "COYOTE_WIRELESS_ISL", NULL },
    { "COYOTE_WIRELESS_SOFTMAC", NULL },
    { "COYOTE_WIRELESS_RALINK", NULL },
    { "COYOTE_EEP", NULL },
    { "COYOTE_ATM_WIRELESS", NULL },
    { "COYOTE_CAC", NULL },
    { "COYOTE_JABIL", NULL },
    { "BRUCE", NULL },
    { "RGLOADER_BRUCE", NULL },
    { "COYOTE_ATM_WIRELESS_ISL", "Coyote with ADSL and Wireless" },
    { "COYOTE_ALL", "Coyote with everything on it" },
    { "COYOTE_FRANCE_TELECOM", NULL},
    { "COYOTE_ATM", NULL },
    { "COYOTE_FULLSOURCE", NULL },
    { "COYOTE_CYBERTAN", NULL },
    { "COYOTE_UMEC", NULL },
    { "COYOTE_BKTEL", NULL },
    { "COYOTE_POSSIO", NULL },
    { "COYOTE_SRI", NULL },
    { "COYOTE_ADEPT", NULL },
    { "COYOTE_EXAVERA", NULL },
    { "COYOTE_JSTREAM", NULL },
    { "COYOTE_DIALFACE", NULL },
    { "COYOTE_EICON", NULL },
    { "NAPA", NULL },
    { "BAMBOO", NULL },
    { "BAMBOO_ALADDIN", NULL },
    { "USR8200", NULL },
    { "USR8200_ALADDIN", NULL },
    { "USR8200_EVAL", NULL },
    { "USR8200_TUTORIAL", NULL },
    { "GTWX5715", NULL }, /* Gemtek AP (router) */
    { "GTWX5715_WIRELESS", NULL }, /* Gemtek AP (router) Wireless */
    { "IXDP425_CYBERTAN", NULL },
    { "WAV54G", NULL },
    { "MONTEJADE", NULL },
    { "MONTEJADE_AGN100", NULL },
    { "MONTEJADE_ATM", NULL },
    { "MONTEJADE_SERVER", NULL },
    { "MI424WR", NULL },
    { "MI524WR", NULL },
    { "MI424WR_VOIP", NULL },
    { "MI424WR_LSP", NULL },
    { "VI414WG", NULL },
    { "VI414WG_ETH", NULL },
    { "KI414WG", NULL },
    { "KI414WG_ETH", NULL },
    { "VI414WG_LSP", NULL },
    { "BA214WG", NULL },
    { "RI408", NULL },
    { "RI408_WIRELESS", NULL },
    { "RI408WR_LSP", NULL },
    { "UML_BHR", "UML for BHR (simulate MI424WR)" },
    { "COYOTE_BHR", "COYOTE for BHR (simulate MI424WR)" },

    /* REDBOOT distributions for IXP425 based boards */
    { "REDBOOT_RICHFIELD", NULL },
    { "REDBOOT_MATECUMBE", NULL },
    { "REDBOOT_COYOTE", NULL },
    { "REDBOOT_NAPA", NULL },
    
    { "CX8620XR_LSP", NULL },
    { "CX8620XD_LSP", NULL },
    { "CX8620XR", NULL},
    { "CX8620XD_FILESERVER", NULL },
    { "CX8620XD_SOHO", NULL },
    { "RGLOADER_CX8620XD", NULL },

    /* RGLOADER distributions */
    { "RGLOADER_MATECUMBE", NULL },
    { "RGLOADER_IXDP425", NULL },
    { "RGLOADER_IXDP425_16MB", NULL },
    { "RGLOADER_IXDP425_LSP", NULL },
    { "RGLOADER_IXDP425_FULLSOURCE", NULL },
    { "RGLOADER_NAPA", NULL },
    { "RGLOADER_KINGSCANYON", NULL },
    { "RGLOADER_ROCKAWAYBEACH", NULL },
    { "RGLOADER_USR8200", NULL },
    { "RGLOADER_COYOTE", NULL },
    { "RGLOADER_COYOTE_64MB_RAM", NULL },
    { "RGLOADER_COYOTE_64MB_RAM_32MB_FLASH", NULL },
    { "RGLOADER_COYOTE_LSP", NULL },
    { "RGLOADER_COYOTE_FULLSOURCE", NULL },
    { "RGLOADER_HG21", NULL },
    { "RGLOADER_GTWX5715", NULL },
    { "RGLOADER_BAMBOO", NULL },
    { "RGLOADER_ALLWELL_RTL_RTL", NULL },
    { "RGLOADER_ALLWELL_RTL_EEP", NULL },
    { "RGLOADER_ALLWELL_EEP_EEP", NULL },
    { "RGLOADER_UML", NULL },
    { "RGLOADER_WAV54G", NULL },
    { "RGLOADER_X86_TMT", NULL },
    { "RGLOADER_INCAIP", NULL },
    { "RGLOADER_ALLTEK", NULL },

    { "RGLOADER_ALLTEK_FULLSOURCE", NULL },

    { "RGLOADER_FLEXTRONICS", NULL },
    { "RGLOADER_MONTEJADE", NULL },
    { "RGLOADER_MI424WR", NULL },
    { "RGLOADER_MI524WR", NULL },
    { "RGLOADER_RI408WR", NULL },
    { "RGLOADER_VI414WG", NULL },
    { "RGLOADER_KI414WG", NULL },
    { "RGLOADER_BA214WG", NULL },

    /* TI WPA VxWorks distribution */
    { "TI_WPA_VX", NULL },
    /* TI VxWorks distribution */
    { "TI_404_VX_EVAL", NULL },
    { "TI_404_VX_CH_ESCROW_FULL", NULL },
    { "TI_404_VX_CH_ESCROW_PARTIAL", NULL },
    { "TI_TNETC440_VX_CH", NULL },
    { "HITRON_TNETC440_VX", NULL },
    { "HITRON_TNETC440_VX_CH", NULL },
    { "TI_404_VX_CH_EVAL", NULL },
    { "ARRIS_TI_404_VX", NULL },
    { "ARRIS_TI_404_VX_CH", NULL },

    /* Toshiba distributions (binary image used for other customers as well,
     * and thus the ambiguous name).
     */
    { "T_TI_404_VX", NULL },
    { "T_TI_404_VX_CH", NULL },

    /* Atheros AR531x VxWorks distribution */
    { "AR2313_LIZZY", NULL },
    { "AR2313_ZIPPY", NULL },
    { "ATHEROS_AR531X_VX", NULL },
    { "WRT108G_VX", NULL },
    { "WRT55AG", NULL },
    /* WRT55AG running on atheros reference board without 802.11a */
    { "WRT55AG_INT", NULL },
    /* Atheros reference board with A+G */
    { "ATHEROS_AR531X_AG_VX", NULL },
 
    /* i386 for Bochs emulation */
    { "I386_BOCHS_VX", NULL },
    { "BOCHS_LIZZY", NULL },
    { "BOCHS_ZIPPY", NULL },

    /* Valgrind */
    { "ALLWELL_RTL_RTL_VALGRIND", NULL },

    /* User Mode Linux with ATM_NULL*/
    { "UML_ATM", NULL },
    
    /* UML_ATM-Valgrind */
    { "UML_ATM_VALGRIND", NULL },

    /* User Mode Linux */
    { "UML", NULL },
    
    { "UML_LSP", NULL },
    
    /* UML-Valgrind */
    { "UML_VALGRIND", NULL },

    /* UML with IPPhone and Valgrind */
    { "UML_IPPHONE_VALGRIND", NULL },
    
    /* UML with IPPhone */
    { "UML_IPPHONE", NULL },

    /* UML with ATA based on RADVISION VoIP stack */
    { "UML_ATA", NULL },

    /* UML with ATA based on oSIP stack */
    { "UML_ATA_OSIP", NULL },

    /* UML with ATA based on oSIP stack and Valgrind */
    { "UML_ATA_OSIP_VALGRIND", NULL },
    
    /* UML with ATA and Valgrind */
    { "UML_ATA_VALGRIND", NULL },
    
    /* CENTAUR */
    { "CENTAUR", "MICREL CENTAUR KS8695PX" },
    { "CENTAUR_VGW", "MICREL CENTAUR KS8695PX VOICE GATEWAY" },
    { "CENTAUR_LSP", "MICREL CENTAUR KS8695PX LSP" },
    { "RGLOADER_CENTAUR", "MICREL CENTAUR KS8695PX RGLOADER" },

    /* JPKG */
    { "JPKG_SRC", NULL },
    { "JPKG_I386", NULL },
    { "JPKG_UML", NULL },
    { "JPKG_ARMV5B", NULL },
    { "JPKG_ARMV5L", NULL },
    { "JPKG_PPC", NULL },
    { "JPKG_MIPSEB", NULL },
    { "JPKG_XSCALE", NULL },
    { "JPKG_ARM_920T_LE", NULL },

    { "FULL", "Full distribution (OS-less, HW-less)" },

    { NULL, NULL }
};

option_t openrg_config_options[] = {
    /* The following are device configs - for each new device type, add
     * a config, so we'll know it exists in an image. */
    { "CONFIG_RG_DEV_IF_EEPRO100", NULL },
    { "CONFIG_RG_DEV_IF_EEPRO1000", NULL },
    { "CONFIG_RG_DEV_IF_ETH1394", NULL },
    { "CONFIG_RG_DEV_IF_INCAIP_ETH", NULL },
    { "CONFIG_RG_DEV_IF_INCAIP_VLAN", NULL },
    { "CONFIG_RG_DEV_IF_ISL38XX", NULL, },
    { "CONFIG_RG_DEV_IF_ISL_SOFTMAC", NULL, },
    { "CONFIG_RG_DEV_IF_BCM43XX", NULL, OPT_HC },
    { "CONFIG_RG_DEV_IF_PRISM2", NULL, },
    { "CONFIG_RG_DEV_IF_RT2560", NULL, },
    { "CONFIG_RG_DEV_IF_RT2561", NULL, },
    { "CONFIG_RG_DEV_IF_AGN100", NULL },
    { "CONFIG_RG_DEV_IF_AR531X_WLAN_G", NULL, },
    { "CONFIG_RG_DEV_IF_AR531X_WLAN_A", NULL, },
    { "CONFIG_RG_DEV_IF_AR531X_ETH", NULL, },
    { "CONFIG_RG_DEV_IF_IXP425_DSL", NULL },
    { "CONFIG_RG_DEV_IF_IXP425_ETH", NULL },
    { "CONFIG_RG_DEV_IF_NATSEMI", NULL },
    { "CONFIG_RG_DEV_IF_NE2000", NULL },
    { "CONFIG_RG_DEV_IF_NE2K_VX", NULL },
    { "CONFIG_RG_DEV_IF_RTL8139", NULL },
    { "CONFIG_RG_DEV_IF_MPC82XX_ETH", NULL },
    { "CONFIG_RG_DEV_IF_TI404_CBL", NULL },
    { "CONFIG_RG_DEV_IF_TI404_LAN", NULL },
    { "CONFIG_RG_DEV_IF_TI_CABLE", NULL },
    { "CONFIG_RG_DEV_IF_UML", NULL },
    { "CONFIG_RG_DEV_IF_UML_HW_SWITCH", NULL },
    { "CONFIG_RG_DEV_IF_USB_RNDIS", NULL },
    { "CONFIG_RG_DEV_IF_VLAN", NULL },
    { "CONFIG_RG_DEV_IF_PPPOA", NULL },
    { "CONFIG_RG_DEV_IF_PPPOE", NULL },
    { "CONFIG_RG_DEV_IF_PPPOES_CONN", NULL },
    { "CONFIG_RG_DEV_IF_PPPOH", NULL },
    { "CONFIG_RG_DEV_IF_ETHOA", NULL },
    { "CONFIG_RG_DEV_IF_PPTPC", NULL },
    { "CONFIG_RG_DEV_IF_PPTPS_CONN", NULL },
    { "CONFIG_RG_DEV_IF_IPSEC_DEV", NULL },
    { "CONFIG_RG_DEV_IF_IPSEC_CONN", NULL },
    { "CONFIG_RG_DEV_IF_IPSEC_TEMPL", NULL },
    { "CONFIG_RG_DEV_IF_IPSEC_TEMPL_CONN", NULL },
    { "CONFIG_RG_DEV_IF_BRIDGE", NULL },
    { "CONFIG_RG_DEV_IF_CHWAN_MASTER", NULL },
    { "CONFIG_RG_DEV_IF_DOCSIS", NULL },
    { "CONFIG_RG_DEV_IF_ETH_SHADOW", NULL },
    { "CONFIG_RG_DEV_IF_ELCP", NULL },
    { "CONFIG_RG_DEV_IF_CAS", NULL },
    { "CONFIG_RG_DEV_IF_CLIP", NULL },
    { "CONFIG_RG_DEV_IF_L2TPC", NULL },
    { "CONFIG_RG_DEV_IF_TICPE", NULL },
    { "CONFIG_RG_DEV_IF_USER_VLAN", NULL },
    { "CONFIG_RG_DEV_IF_IPV6_OVER_IPV4_TUN", NULL },
    { "CONFIG_RG_DEV_IF_IPOA", NULL },
    { "CONFIG_RG_DEV_IF_ATM_NULL", NULL },
    { "CONFIG_RG_DEV_IF_BCM963XX_ETH", NULL },
    { "CONFIG_RG_DEV_IF_CX821XX_ETH", NULL },
    { "CONFIG_RG_DEV_IF_BCM963XX_ADSL", NULL },
    { "CONFIG_RG_DEV_IF_BCM4710_ETH", NULL },
    { "CONFIG_RG_DEV_IF_ADM5120_ETH", NULL },
    { "CONFIG_RG_DEV_IF_CX8620X_SWITCH", NULL },
    { "CONFIG_RG_DEV_IF_KS8695_ETH", NULL },
    { "CONFIG_RG_DEV_IF_KS8995M_HW_SWITCH", NULL },
    { "CONFIG_RG_DEV_IF_MV88E6083_HW_SWITCH", NULL },
    { "CONFIG_RG_DEV_IF_ADM6996_HW_SWITCH", NULL },
    { "CONFIG_RG_DEV_IF_CLINK", NULL },
    { "CONFIG_RG_DEV_IF_MOCA_PCI", NULL },
    { "CONFIG_RG_DEV_IF_VINAX", NULL },
    { "CONFIG_RG_DEV_IF_IKANOS_VDSL", NULL },
    { "CONFIG_RG_DEV_IF_AMAZON_ETH", NULL },
    { "CONFIG_RG_DEV_IF_AMAZON_ADSL" },
    /* End of device type configs */

    /* u-boot */
    { "CONFIG_BOOTLDR_UBOOT", NULL, OPT_HC },
    { "CONFIG_BOOTLDR_UBOOT_COMP", NULL, OPT_STR },

    { "RG_PROD_STR", NULL, OPT_C_STR },
    { "CONFIG_RG_OS", NULL, OPT_C_STR },
    { "CONFIG_RG_HW", NULL, OPT_HC | OPT_C_STR },
    { "CONFIG_RG_DEV_IF_SL2312_ETH", NULL },
    { "CONFIG_RG_HW_DESC_STR", NULL, OPT_HC | OPT_C_STR },
    { "CONFIG_RG_DIST", NULL, OPT_HC | OPT_C_STR },
    /* Performing remote upgrade in RGLoader should compare dist derived from
     * RGloader. 
     * For example: RGLOADER_MI424WR can load images that match MI424WR */
    { "CONFIG_RG_RMT_UPD_DIST", NULL, OPT_HC | OPT_C_STR },
    { "CONFIG_RG_JPKG", NULL, OPT_MK },
    { "CONFIG_RG_JPKG_DEBUG", NULL, OPT_MK },
    { "CONFIG_RG_JPKG_SRC", NULL, OPT_HC },
    { "CONFIG_RG_JPKG_BIN", NULL },
    { "CONFIG_RG_JPKG_I386", NULL },
    { "CONFIG_RG_JPKG_UML", NULL },
    { "CONFIG_RG_JPKG_ARMV5B", NULL },
    { "CONFIG_RG_JPKG_ARMV5L", NULL },
    { "CONFIG_RG_JPKG_PPC", NULL },
    { "CONFIG_RG_JPKG_MIPSEB", NULL },
    { "CONFIG_RG_JPKG_XSCALE", NULL },
    { "CONFIG_RG_JPKG_ARM_920T_LE", NULL },
    { "CONFIG_RG_FULL_FEATURES", NULL },
    { "CONFIG_RG_SMB", NULL },
    { "JPKG_DISTS", NULL, OPT_MK | OPT_STR },
    { "JPKG_ARCH", NULL, OPT_H | OPT_STR },
    /* Type of jpkg command needed to create jpkg dist for this DIST. Used by
     * BAT when testing distrebutions */ 
    { "CONFIG_RG_JPKG_DIST", "JPKG_SRC", OPT_MK | OPT_STR },
    { "ARCH", NULL, OPT_C_STR }, /* Linux's ARCH. Change it? */
    { "LIBC_ARCH", NULL, OPT_STR },
    /* archconfig build settings */
    { "CONFIG_BUILD_ARCHCONFIG", NULL },
    /* link all modules that apears as OPT_STATIC_ON_DEVELOP statically. */
    { "CONFIG_RG_DEV", NULL },
    /* combines footprint reduction methods - removal of unreferenced symbols
     * during linkage; bzip2; romfs; export of reduced set of kernel symbols */
    { "CONFIG_RG_FOOTPRINT_REDUCTION", NULL },
    /* Modules are stored in a separate filesystem, which is unmounted and
     * freed once the modules are loaded */
    { "CONFIG_RG_MODFS", NULL },

    { "ENDIANESS_SUFFIX", NULL, OPT_STR },
    { "INTERSIL_EVENTS", NULL }, /* used by Intersil PRISM GT driver to 
				  * determine whether it should indicate
				  * user-mode applications of various events */
    { "OPENRG_DEBUG", NULL },
    { "OPENRG_DEBUG_OPENRG", NULL }, /* openrg statically linked */
    { "OPENRG_DEBUG_EXEC_SH", NULL, OPT_NOSTRIP }, /* Init spawn sh instead of 
						    * openrg */
    { "OPENRG_DEBUG_FILE_OPEN", NULL }, /* Kernel print for any 'open()' */
    { "CONFIG_DEBUG_KMALLOC", NULL }, /* kernel memory debug */
    { "CONFIG_DEBUGSYM", NULL }, /* This enable --debug for UML */
    { "CONFIG_BRIDGE", NULL, OPT_MODULE_EXPAND }, /* Enable kernel bridge */
    { "CONFIG_BRIDGE_UTILS", NULL, OPT_HC },
    { "CONFIG_IPTABLES", NULL, OPT_HC }, /* enable iptables */
    /* enable netfilter in the kernel */
    { "CONFIG_NETFILTER", NULL, OPT_MAJOR_FEATURE, "NetFilter Linux Firewall" },
    { "CONFIG_IP_NF_FILTER", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IP_NF_IPTABLES", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IP_NF_CONNTRACK", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IP_NF_NAT_NEEDED", NULL },
    { "CONFIG_IP_NF_NAT", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IP_NF_NAT_LOCAL", NULL },
    { "CONFIG_IP_NF_TARGET_MASQUERADE", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_EXPORT_BINARIES", NULL },
    { "CONFIG_RG_NO_OPT", NULL }, /* -O0 when compiling usermode. */
    { "CONFIG_LSP_DIST", NULL, OPT_HC }, /* Define LSP distribution */
    { "CONFIG_RG_RGLOADER", NULL, OPT_HC }, /* OpenRG as Rgloader */
    { "CONFIG_RG_NETWORK_BOOT", NULL, OPT_HC }, /* Enable boot of image from
						 * network
						 */
    { "CONFIG_RG_RGLOADER_CLI_CMD", NULL }, /* OpenRG that has the rgloader cli
					     * commands.
					     */
    { "CONFIG_RG_UIEVENTS", NULL },
    { "CONFIG_RG_KLEDS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_KRGLDR", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_KMONTE", NULL, OPT_HC },
    { "CONFIG_SAVE_REAL_MODE_CONF", NULL},
    { "CONFIG_IXP425_POST", NULL },
    { "CONFIG_PCMCIA", NULL, OPT_MODULE_EXPAND | OPT_HC},
    { "CONFIG_80211G_AP_ADVANCED", NULL, OPT_HC },
    { "CONFIG_80211_WDS", NULL, OPT_HC },
    { "CONFIG_PCMCIA_80211B", NULL },
    { "CONFIG_8139TOO", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ALIGNMENT_TRAP", NULL },
    { "CONFIG_ALIGNMENT_TRAP_MODE", NULL, OPT_NUMBER },
    { "CONFIG_APM", NULL },
    { "CONFIG_APM_POWER_OFF", NULL },
    { "CONFIG_APP_IPR", NULL },
    { "CONFIG_ARCH_CNXT", NULL },
    { "CONFIG_ARCH_CX821XX", NULL },
    { "CONFIG_ARCH_IXP22X", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_IXDP425", NULL },
    { "CONFIG_ARCH_IXP425_MATECUMBE", NULL },
    { "CONFIG_ARCH_IXP425_COYOTE", NULL },
    { "CONFIG_ARCH_IXP425_KINGSCANYON", NULL },
    { "CONFIG_ARCH_IXP425_ROCKAWAYBEACH", NULL },
    { "CONFIG_ARCH_IXP425_HG21", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_NAPA", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_BAMBOO", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_JEEVES", NULL, OPT_HC },
    { "CONFIG_JEEVES_RTC7301", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_ARCH_IXP425_GTWX5715", NULL },
    { "CONFIG_ARCH_IXP425_WAV54G", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_MONTEJADE", NULL },
    { "CONFIG_ARCH_IXP425_BRUCE", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_BRUCE_CPLD", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_ARCH_IXP425_MI424WR", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_VI414WG", NULL, OPT_HC },
    { "CONFIG_RG_WBM_READONLY_USERS_GROUPS", NULL, OPT_HC },
    { "CONFIG_ARCH_IXP425_RI408", NULL, OPT_HC },
    { "CONFIG_ARCH_MACHINE", NULL, OPT_STR },
    { "CONFIG_ARM", NULL, OPT_HC },
    { "CONFIG_ARM_THUMB", NULL },
    { "CONFIG_ARMNOMMU", NULL, OPT_HC },
    /* Load kernel 2.4 modules on ARM between user space and kernel core (from
     * 0xbf000000 to 0xc0000000). Notice: this config interfere with kernel
     * debugger. Disable it while debugging.
     */
    { "CONFIG_ARM_24_FAST_MODULES", NULL },
    { "CONFIG_ATALK", NULL, OPT_MODULE_EXPAND },
    /* DSL Module (ATM) */
    { "CONFIG_ATM", NULL, OPT_NOSTRIP | OPT_HC },
    { "CONFIG_ATM_NULL", NULL, OPT_HC },
    { "CONFIG_ATM_BR2684", NULL, OPT_MODULE_EXPAND | OPT_MAJOR_FEATURE,
	"Ethernet over ATM (RFC2684)" },
    { "CONFIG_ATM_CLIP", NULL, OPT_MODULE_EXPAND | OPT_MAJOR_FEATURE, 
	"Classical IP" },
    { "CONFIG_ATM_CONEXANT_DSL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ATM_NICSTAR", NULL },
    { "CONFIG_ATM_NICSTAR_USE_IDT77105", NULL },
    { "CONFIG_ATM_SKB", NULL },
    { "CONFIG_ATM_PVC_SCAN", NULL, OPT_HC | OPT_MAJOR_FEATURE, "PVC Scan" },
    { "CONFIG_RG_ATM_QOS", NULL, OPT_HC },
    { "CONFIG_AUTOFS_FS", NULL },
    /* Zero Configuration Networking */
    { "CONFIG_AUTO_LEARN_DNS", NULL, OPT_HC },
    { "CONFIG_BD_GOLDENGATE", NULL }, /* Conexant CX82100 eval board */
    { "CONFIG_BD_MACKINAC", NULL }, /* Conexant CX82110 eval board */
    { "CONFIG_BD_RUSHMORE", NULL }, /* Conexant CX82310 eval board */
    { "CONFIG_CHIP_CX82100", NULL },
    { "CONFIG_CHIP_CX82110", NULL },
    { "CONFIG_BINFMT_ELF", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BINFMT_FLAT", NULL },
    { "CONFIG_BINUTILS_NEW", NULL },
    { "CONFIG_BLK_DEV_IDE", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BLK_DEV_IDEDISK", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_IDECD", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_IDEDMA", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_IDEDMA_PCI", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_IDEPCI", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_OFFBOARD", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_SIIMAGE", NULL, OPT_NOSTRIP },
    { "CONFIG_BLK_DEV_CS5530", NULL },
    { "CONFIG_BLK_DEV_INITRD", NULL },
    { "CONFIG_BLK_DEV_LOOP", NULL },
    { "CONFIG_BLK_DEV_RAM", NULL },
    { "CONFIG_BLK_DEV_RAM_SIZE", NULL, OPT_STR },
    { "CONFIG_BLK_DEV_VIA82CXXX", NULL },
    { "CONFIG_EMBEDDED_RAMDISK", NULL },
    { "CONFIG_BOOT_FREE_MEM_END", NULL },
    { "CONFIG_BOOT_FREE_MEM_START", NULL },
    { "CONFIG_BOOT_RAM_POS", NULL },
    { "CONFIG_BOOT_SP_POS", NULL },
    { "CONFIG_BSD_PROCESS_ACCT", NULL },
    { "CONFIG_BURNER_POS", NULL },
    { "CONFIG_CARDBUS", NULL },
    { "CONFIG_CD_NOPKG", NULL },
    { "CONFIG_CMDLINE", NULL, OPT_C_STR },
    { "CONFIG_CMDLINE_BOOL", NULL },
    { "CONFIG_CNXT_EMAC", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CNXT_ADSL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CNXT_ATM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CNXT_SOFTSAR", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ETHOA_STANDALONE", NULL },
    { "CONFIG_CNXT_TERMINAL", NULL },
    { "CONFIG_CONEXANT_DSL_TIGRIS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CONEXANT_DSL_YUKON", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_COPY_CRAMFS_TO_RAM", NULL },
    { "CONFIG_CRAMFS_DYN_BLOCKSIZE", NULL },
    { "CONFIG_CRAMFS_BLKSZ", NULL, OPT_NUMBER },
    { "CONFIG_CPLUSPLUS", NULL },
    { "CONFIG_CPU_32", NULL },
    { "CONFIG_CPU_32v4", NULL },
    { "CONFIG_CPU_32v5", NULL },
    { "CONFIG_CPU_ADVANCED", NULL },
    { "CONFIG_CPU_ARM7", NULL },
    { "CONFIG_CPU_ARM940_CPU_IDLE", NULL },
    { "CONFIG_CPU_ARM940_D_CACHE_ON", NULL },
    { "CONFIG_CPU_ARM940_I_CACHE_ON", NULL },
    { "CONFIG_CPU_ARM940T", NULL },
    { "CONFIG_CPU_ARM940_WRITETHROUGH", NULL },
    { "CONFIG_CPU_BIG_ENDIAN", NULL },
    { "CONFIG_CPU_LITTLE_ENDIAN", NULL },
    { "CONFIG_CPU_MIPS32", NULL },
    { "CONFIG_CPU_XSCALE", NULL },
    { "CONFIG_CPU_ARM926T", NULL },
    { "CONFIG_ROMFS_FS", NULL, OPT_HC },
    { "CONFIG_RG_BZIP2", NULL, OPT_HC },
    { "CONFIG_CPU_ARM922T", NULL },
    { "CONFIG_CPU_ARM922_CPU_IDLE", NULL },
    { "CONFIG_CPU_ARM922_I_CACHE_ON", NULL },
    { "CONFIG_CPU_ARM922_D_CACHE_ON", NULL },
    { "CONFIG_RG_NONCOMPRESSED_USERMODE_IMAGE", NULL },
    { "CONFIG_CRAMFS", NULL },
    { "CONFIG_CRAMFS_FS", NULL },
    { "CONFIG_CRAMFS_FS_COMMON", NULL },
    { "CONFIG_CRAMFS_IN_RAM", NULL },
    { "CONFIG_CRAMFS_IN_RAM_OFFSET", NULL },
    { "CONFIG_CRAMFS_LINEAR", NULL },
    { "RG_BLOCK_SIZE_BITS", NULL },
    { "CONFIG_CRAMFS_RAM_ADDR", NULL },
    { "CONFIG_CROSSCOMPILE", NULL },
    { "CONFIG_CONEXANT_COMMON", NULL },
    { "CONFIG_CX821XX_COMMON", NULL, OPT_HC },
    { "CONFIG_CX821XX_MXIC_FLASH", NULL },
    { "CONFIG_GEMTEK_COMMON", NULL },
    { "CONFIG_GEMTEK_WX5715", NULL, OPT_HC },
    /* Intersil Wireless */
    { "CONFIG_INTERSIL_COMMON", NULL }, 
    { "CONFIG_ISL38XX", NULL, OPT_MODULE_EXPAND | OPT_NOSTRIP }, 
    /* Intersil Javelin Wireless */
    { "CONFIG_ISL_SOFTMAC", NULL, OPT_MODULE_EXPAND | OPT_NOSTRIP },
    /* Wireless Tools for Ralink Wireless */
    { "CONFIG_WIRELESS_TOOLS", NULL, OPT_HC },
    /* Ralink RT2560 Wireless */
    { "CONFIG_RALINK_RT2560", NULL, OPT_MODULE_EXPAND | OPT_NOSTRIP },
    { "CONFIG_RALINK_RT2560_TIMECSR", NULL, OPT_NUMBER },
    /* Ralink RT2561 Wireless */
    { "CONFIG_RALINK_RT2561", NULL, OPT_MODULE_EXPAND | OPT_NOSTRIP },
    /* Airgo AGN100 Wireless */
    { "CONFIG_AGN100", NULL, OPT_MODULE_EXPAND | OPT_NOSTRIP },
    { "CONFIG_DE4X5", NULL },
    { "CONFIG_DEBUG_LL", NULL, OPT_NOSTRIP },
    { "CONFIG_DEBUG_USER", NULL },
    { "CONFIG_DELIVER_GDBSERVER", NULL },
    { "CONFIG_DEVPTS_FS", NULL },
    { "CONFIG_DEF_KEYS", NULL },
    { "CONFIG_DHCP_TIMEOUT", NULL },
    { "CONFIG_DIST_", NULL },
    { "CONFIG_DSL", NULL },
    { "CONFIG_DSL_SYNCD", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_DUETTE", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_DUMMY_CONSOLE", NULL },
    { "CONFIG_DYN_LINK", NULL },
    { "CONFIG_ULIBC_SHARED", NULL }, /* Need support for Ulibc as shared object
				      * even if all linkage is static */
    { "CONFIG_EEPRO100", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_E1000", NULL },
    { "CONFIG_EEXPRESS_PRO100", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ESP_NULL_MD5_96", NULL },
    { "CONFIG_ESP_NULL_SHA1_96", NULL },
    { "CONFIG_EST8xx", NULL },
    { "LIC", NULL, OPT_STR },
    { "LICSTR", NULL, OPT_STR },
    { "LIC_AUTOCONF", NULL },
    { "LIC_FORCE", NULL }, /* Override license engine when building image */
    /* Do not remove/change. CONFIG_LICENSE_AGREEMENT is added to MAKEFLAGS 
     * in rg/archconfig.mak - any changes must be made there as well
     */
    { "CONFIG_LICENSE_AGREEMENT", NULL,
	OPT_MAJOR_FEATURE | OPT_NOSTRIP | OPT_HC,
	"WBM Evaluation License Agreement" },
    { "CONFIG_EVEREX", NULL },
    { "CONFIG_EXP_BUS_SHL", NULL },
    { "CONFIG_EXPERIMENTAL", NULL },
    { "CONFIG_EXT2_FS", NULL },
    { "CONFIG_EXT3_FS", NULL }, /* Ext3 journalling file system support */
    { "CONFIG_JBD", NULL }, /* Journal Block Device support (JBD for ext3) */
    { "CONFIG_EXTRA_ALLOC", NULL },
    { "CONFIG_FAST_RAM", NULL },
    { "CONFIG_FPE_NWFPE", NULL },
    { "CONFIG_FPE_FASTFPE", NULL },
    { "CONFIG_FPE_NWFPE_XP", NULL },
    { "CONFIG_FILTER", NULL },
    { "CONFIG_FLASH_FSTYPE", NULL },
    { "CONFIG_FLASH_IMAGE_OFFSET", NULL },
    { "CONFIG_FLASH_POS", NULL },
    { "CONFIG_FORCE_MAX_ZONEORDER", NULL, OPT_NUMBER },
    { "CONFIG_FRAME_POINTER", NULL, OPT_NOSTRIP },
    { "CONFIG_MAGIC_SYSRQ", NULL, OPT_NOSTRIP },
    { "CONFIG_FREEPAGES_HIGH", NULL, OPT_NUMBER },
    { "CONFIG_FREEPAGES_LOW", NULL, OPT_NUMBER },
    { "CONFIG_FREEPAGES_MIN", NULL, OPT_NUMBER },
    { "CONFIG_FREEPAGES_THRESHOLD", NULL },
    /* VPN IPSec */
    { "CONFIG_FREESWAN", NULL, OPT_HC },
    { "CONFIG_RG_NETBIOS_RT", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_GDB", NULL, OPT_NOSTRIP },
    { "CONFIG_GDB_CONSOLE", NULL, OPT_NOSTRIP },
    { "CONFIG_GEN_RG_DEFAULT", NULL },
    { "CONFIG_GLIBC", NULL, OPT_HC },
    { "CONFIG_GMP", NULL, OPT_HC },
    { "CONFIG_HAS_MMU", NULL },
    { "CONFIG_HAVE_STD_PC_SERIAL_PORT", NULL },
    { "CONFIG_HPNA", NULL },
    { "CONFIG_IDEDMA_AUTO", NULL, OPT_NOSTRIP },
    { "CONFIG_IDE", NULL, OPT_NOSTRIP },
    { "CONFIG_IDEDISK_MULTI_MODE", NULL, OPT_NOSTRIP },
    { "CONFIG_DEF_BRIDGE_LANS", NULL, OPT_HC },
    { "CONFIG_DEF_BRIDGE_WAN", NULL, OPT_HC },
    { "CONFIG_DEF_WAN_BRIDGE_FALLBACK_IP", NULL, OPT_HC },
     /* Allow IDE probing in separate kernel thread  */
    { "CONFIG_RG_IDE_NON_BLOCKING", NULL },
    /* Set the following to yes if you want the bridge to have an alternative
     * IP, which is used at all times that the bridge has no real IP (whether
     * static or dynamic). Currently used for xg1000.
     * Caution: This is not a fallback IP (a fallback IP is used only upon
     * failure of DHCP client to acquire a lease).
     */
    { "CONFIG_DEF_BRIDGE_ALTERNATE_IP", NULL, OPT_HC }, 
    { "CONFIG_DEF_WAN_ALIAS_IP", NULL,  OPT_HC }, 
    { "CONFIG_IEEE1394", NULL, OPT_MODULE_EXPAND }, 
    { "CONFIG_IEEE1394_OHCI1394", NULL, OPT_MODULE_EXPAND }, 
    { "CONFIG_IEEE1394_ETH1394", NULL, OPT_MODULE_EXPAND }, 
    { "CONFIG_IEEE1394_SBP2", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IMG_PRODUCT", NULL },
    { "CONFIG_IMG_SREC_SLICES", NULL },
    { "CONFIG_INET", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INIT_BASIC_RUNLEVELS", NULL, OPT_HC },
    { "CONFIG_INITRD_ADDR", NULL },
    { "CONFIG_INITRD_IN_IMAGE", NULL },
    { "CONFIG_IP_ADVANCED_ROUTER", NULL },
    { "CONFIG_IP_MULTICAST", NULL, OPT_HC },
    { "CONFIG_IPSEC", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Internet Protocol Security" },
    { "CONFIG_IPSEC_AH", NULL },
    { "CONFIG_IPSEC_AUTH_HMAC_MD5", NULL },
    { "CONFIG_IPSEC_ALG_MD5", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_AUTH_HMAC_SHA1", NULL },
    { "CONFIG_IPSEC_ALG_SHA1", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_CON_PASSTHRU_TRANSFER", NULL },
    { "CONFIG_IPSEC_DEBUG", NULL },
    { "CONFIG_IPSEC_ENC_3DES", NULL },
    { "CONFIG_IPSEC_ALG_3DES", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_ENC_1DES", NULL },
    { "CONFIG_IPSEC_ALG_1DES", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_ENC_NULL", NULL },
    { "CONFIG_IPSEC_ALG_NULL", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_ENC_AES", NULL, OPT_HC },
    { "CONFIG_IPSEC_ALG_AES", NULL, OPT_MODULE_EXPAND},
    { "CONFIG_IPSEC_ESP", NULL },
    { "CONFIG_IPSEC_IPCOMP", NULL },
    { "CONFIG_IPSEC_IPIP", NULL },
    { "CONFIG_RG_IPSEC_NO_SECRET_FILE", NULL },
    { "CONFIG_IPSEC_USE_IXP4XX_CRYPTO", NULL, OPT_NOSTRIP },
    { "CONFIG_IPSEC_DRIVER", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_IPSEC_ESP_ALG", NULL},
    { "CONFIG_RG_IPSEC_IKE_ALG", NULL},
    { "CONFIG_IPSEC_ALG", NULL},
    { "CONFIG_IXP_CS8900", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ARCH_IXP425", NULL, OPT_HC },
    { "CONFIG_IXP425", NULL },
    { "CONFIG_IXP425_CODELET_DSP_ENG", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_ATM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_ETH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_HSS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_USB", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_DMA", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_CRYPTO", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_PERF_PROF", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELET_TIMERS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_CODELETS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_COMMON", NULL, OPT_HC },
    { "CONFIG_IXP425_COMMON_RG", NULL },
    { "CONFIG_IXP425_COMMON_RGLOADER", NULL },
    { "CONFIG_IXP425_COMMON_LSP" },
    { "CONFIG_IXP425_CSR", NULL, OPT_MODULE_EXPAND },
    /* LAN Driver - DSP Voice Driver */
    { "CONFIG_IXP425_DSR", NULL, OPT_MODULE_EXPAND | OPT_MAJOR_FEATURE, 
	"Intel DSR support" },
    { "CONFIG_IXP425_DSR_DEMO", NULL },
    { "CONFIG_IXP425_CSR_FULL" },
    { "CONFIG_IXP425_CSR_ATM", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_ETH_ACC", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_ETH_DB", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_ETH_MII", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_DMA_ACC", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_CRYPTO_ACC", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_PERF_PROF_ACC", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_HSS", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_USB", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_UART", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_CSR_ETHDB", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_ETH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_ETH_MAC0_PHYID", NULL, OPT_NUMBER },
    { "CONFIG_IXP425_ETH_MAC1_PHYID", NULL, OPT_NUMBER },
    { "CONFIG_IXP425_ATM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_FLASH_E28F128J3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_FLASH_E28F640J3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_FLASH_E28F320J3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IXP425_FLASH_USER_PART", NULL, OPT_NOSTRIP },
    { "CONFIG_IXP425_OS_TIMER1", NULL },
    { "CONFIG_IXP425_PCI_NP_WORKAROUND", NULL },
    { "CONFIG_IXP425_JFFS2_WORKAROUND", NULL },
    /* Amount of memory on board: 32, 64, 128 and 256 MB. */
    { "CONFIG_IXP425_SDRAM_SIZE", NULL, OPT_NUMBER },
    /* RAM memory chips count */
    { "CONFIG_IXP425_NUMBER_OF_MEM_CHIPS", NULL, OPT_NUMBER },
    /* Flash memory chips count */
    { "CONFIG_IXP425_NUMBER_OF_FLASH_CHIPS", NULL },
    { "CONFIG_ADSL_LOOPBACK_TEST", NULL },
    { "CONFIG_IXP425_ADSL_USE_SPHY", NULL },
    { "CONFIG_IXP425_ADSL_USE_MPHY", NULL },
    { "CONFIG_JFFS2_FS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_KCORE_ELF", NULL },
    { "CONFIG_KERNEL_ASSERTS", NULL, OPT_NOSTRIP },
    { "CONFIG_KERNEL_ELF", NULL },
    { "CONFIG_KERNEL_FLASH_POS", NULL },
    { "CONFIG_FLASH_START_ADDR", NULL },
    { "CONFIG_KERNEL_MATH_EMULATION", NULL },
    { "CONFIG_KERNEL_RAM_POS", NULL },
    { "CONFIG_KERNEL_RAM_SIZE", NULL },
    { "CONFIG_KEYBOARD", NULL },
    { "CONFIG_KGDB", NULL, OPT_NOSTRIP },
    { "CONFIG_KGDB_SERIAL", NULL, OPT_NOSTRIP },
    { "CONFIG_KGDB_CONSOLE", NULL, OPT_NOSTRIP },
    { "CONFIG_IXDP425_KGDB_UART", NULL, OPT_NOSTRIP | OPT_NUMBER },
    { "CONFIG_KGDB_THREAD", NULL, OPT_NOSTRIP },
    { "CONFIG_LAN_SAA9730", NULL },
    { "CONFIG_LIBDES", NULL },
    { "CONFIG_LINUX_BSP", NULL },
    { "CONFIG_LINUX_OAM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_LOCKD", NULL, OPT_MODULE_EXPAND },
    /* I2C Bus*/
    { "CONFIG_I2C", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_I2C_ALGOBIT", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_I2C_IXP425", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_I2C_DS1374", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_I2C_LM81", NULL, OPT_MODULE_EXPAND },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_LOG_FILES_MAX_SIZE", NULL, OPT_NUMBER },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_LOG_FILES_MIN_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_M386", NULL },
    { "CONFIG_MACH_SPECIFIC", NULL },
    { "CONFIG_MALLOC_CONSERVE_RAM", NULL },
    { "CONFIG_MATH_EMULATION", NULL },
    { "CONFIG_MINIX_FS", NULL },
    { "CONFIG_MIPS", NULL, OPT_HC },
    { "CONFIG_MIPS32", NULL },
    { "CONFIG_MIPS64", NULL },
    { "CONFIG_MIPS_ATLAS", NULL },
    { "CONFIG_MIPS_FPU_EMULATOR", NULL },
    { "CONFIG_MIPS_IDT", NULL },
    { "CONFIG_MIPS_MALTA", NULL },
    { "CONFIG_RG_INSMOD_SILENT", NULL, OPT_HC },
    { "CONFIG_DIVDI3", NULL },
    /* Inca ops */	
    { "CONFIG_INCAIP", NULL, OPT_HC },
    { "CONFIG_INCA_IP", NULL },
    { "CONFIG_INCAIP_COMMON", NULL },
    { "CONFIG_INCAIP_ALLTEK", NULL },
    { "CONFIG_INCAIP_KEYPAD",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_LEDMATRIX",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_DSP",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_FLEXTRONICS", NULL },
    /* LAN Driver - DSP Voice Driver */
    { "CONFIG_VINETIC", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_VINETIC_TAPIDEMO", NULL },
    { "CONFIG_VINETIC_LINES_PER_CHIP", NULL },
    { "CONFIG_VINAX", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IKANOS_VDSL", NULL, OPT_H | OPT_HC | OPT_MK },
    { "CONFIG_INCAIP_IOM2", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_ETHERNET",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_PSEUDO_LAN", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIPSSC",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIPPWM",  NULL, OPT_MODULE_EXPAND },
    { "CONFIG_SERIAL_INCAIPASC", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_SERIAL_INCAIPASC_CONSOLE", NULL },
    { "CONFIG_INCAIPASC_DEFAULT_BAUDRATE", NULL },
    { "CONFIG_INCAIP_EVALBOARD", NULL },
    { "CONFIG_MTD_INCAIP", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_WATCHDOG", NULL, },
    { "CONFIG_INCAIP_WATCHDOG_HEARTBEAT", NULL, },
    { "CONFIG_INCAIP_WATCHDOG_TIMEOUT", NULL, },
    { "CONFIG_INCAIP_MUX", NULL },
    { "CONFIG_INCAIP_MUX_KEY0", NULL },
    { "CONFIG_INCAIP_MUX_KEY1", NULL },
    { "CONFIG_INCAIP_MUX_KEY2", NULL },
    { "CONFIG_INCAIP_MUX_KEY3", NULL },
    { "CONFIG_INCAIP_MUX_KEY4", NULL },
    { "CONFIG_INCAIP_MUX_KEY5", NULL },
    { "CONFIG_INCAIP_MUX_KEY6", NULL },
    { "CONFIG_INCAIP_MUX_KEY7", NULL },
    { "CONFIG_INCAIP_MUX_LED0", NULL },
    { "CONFIG_INCAIP_MUX_LED1", NULL },
    { "CONFIG_INCAIP_MUX_LED2", NULL },
    { "CONFIG_INCAIP_MUX_LED3", NULL },
    { "CONFIG_INCAIP_MUX_LED4", NULL },
    { "CONFIG_INCAIP_MUX_LED5", NULL },
    { "CONFIG_INCAIP_MUX_LED6", NULL },
    { "CONFIG_INCAIP_MUX_LED7", NULL },
    { "CONFIG_INCAIP_MUX_LED8", NULL },
    { "CONFIG_INCAIP_MUX_RXD", NULL },
    { "CONFIG_INCAIP_MUX_TXD", NULL },
    { "CONFIG_INCAIP_MUX_SSC1", NULL },
    { "CONFIG_INCAIP_MUX_SSC2", NULL },
    { "CONFIG_INCAIP_MUX_FSC", NULL },
    { "CONFIG_INCAIP_MUX_DCL", NULL },
    { "CONFIG_INCAIP_MUX_DU", NULL },
    { "CONFIG_INCAIP_MUX_DD", NULL },
    { "CONFIG_INCAIP_MUX_PWM1", NULL },
    { "CONFIG_INCAIP_MUX_PWM2", NULL },
    { "CONFIG_INCAIP_MUX_P2_9", NULL },
    { "CONFIG_INCAIP_MUX_P1_16", NULL },
    { "CONFIG_INCAIP_MUX_P1_17", NULL },
    { "CONFIG_INCAIP_MUX_P2_10", NULL },
    { "CONFIG_INCAIP_MUX_P2_11", NULL },
    { "CONFIG_INCAIP_MUX_P2_12", NULL },
    { "CONFIG_INCAIP_MUX_P2_13", NULL },
    { "CONFIG_INCAIP_MUX_P2_14", NULL },
    { "CONFIG_INCAIP_MUX_P2_15", NULL },
    /* LSI Logic ZSP400 VOIP DSP board */
    { "CONFIG_ZSP400", NULL, OPT_MODULE_EXPAND },
    /* Inca switch */
    { "CONFIG_INCAIP_SWITCH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCAIP_SWITCH_API", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_INCA_HW_ENCRYPT", NULL },
    /* MPC8272ADS freescale */
    { "CONFIG_MPC8272ADS", NULL, OPT_HC },
    { "CONFIG_PPC32", NULL},
    { "CONFIG_6xx", NULL},
    { "CONFIG_8260", NULL},
    { "CONFIG_CPM2", NULL},
    { "CONFIG_USE_MDIO", NULL},
    { "CONFIG_FCC_DM9161", NULL},
    { "CONFIG_PQ2ADS", NULL},
    { "CONFIG_ADS8272", NULL},
    { "CONFIG_8272", NULL},
    { "CONFIG_PPC_STD_MMU", NULL},
    { "CONFIG_EMBEDDEDBOOT", NULL},
    { "CONFIG_HIGHMEM_START", NULL, OPT_NUMBER },
    { "CONFIG_LOWMEM_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_TASK_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_MBX", NULL},
    { "CONFIG_SCC_CONSOLE", NULL},
    { "CONFIG_FEC_ENET", NULL},
    { "CONFIG_FCC1_ENET", NULL},
    { "CONFIG_FCC2_ENET", NULL},
    { "CONFIG_MTD_JEDECPROBE", NULL},
    { "CONFIG_MTD_CFI_LE_BYTE_SWAP", NULL},
    { "CONFIG_MTD_COMPLEX_MAPPINGS", NULL},
    { "CONFIG_MTD_MPC8272ADS", NULL},
    { "CONFIG_CC_HAVE_VA_COPY", NULL},

    /* ADM5120 */
    { "CONFIG_ADM5120_COMMON", NULL, OPT_HC },
    { "CONFIG_MIPS_AM5120", NULL },
    { "CONFIG_ADM5120_SERIAL", NULL },
    { "CONFIG_ADM5120_MTD", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ADM5120_SWITCH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ADM5120_IPTOS", NULL },
    /* Broadcom ops */
    { "CONFIG_ARCH_BCM947_CYBERTAN", NULL },
    { "CONFIG_RG_BCM947_NVRAM_CONVERT", NULL },
    { "CONFIG_ET", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ET_47XX", NULL },
    { "CONFIG_SIMPLE_CRAMDISK", NULL },
    { "CONFIG_NONCOHERENT_IO", NULL },
    { "CONFIG_MIPS_BRCM", NULL },
    { "CONFIG_BCM947XX", NULL, OPT_HC },
    { "CONFIG_BCM947_COMMON", NULL, OPT_HC },
    { "CONFIG_BCM4710", NULL },
    { "CONFIG_BCM4310", NULL },
    { "CONFIG_BCM4704", NULL },
    { "CONFIG_BCM4702", NULL },
    { "CONFIG_BCM96345" },
    { "CONFIG_BCM96348" },
    { "CONFIG_BCM963XX", NULL, OPT_HC },
    { "CONFIG_BCM963XX_COMMON", NULL },
    { "CONFIG_BCM963XX_BOARD_ID", NULL, OPT_C_STR },
    { "CONFIG_BCM963XX_SDRAM_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_BCM963XX_MTD", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_SERIAL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_BOARD", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_ETH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_ATM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_ADSL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_USB", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_WLAN", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_ENDPOINT", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BCM963XX_PROCFS", NULL, OPT_MODULE_EXPAND },

    /* KS8695PX */
    { "CONFIG_KS8695_COMMON", NULL },
    { "CONFIG_KS8695", NULL },
    { "CONFIG_ARCH_KS8695", NULL },
    { "CONFIG_ARCH_KS8695P", NULL },
    { "CONFIG_PCI_KS8695P", NULL },
    { "CONFIG_SERIAL_KS8695", NULL },
    { "CONFIG_SERIAL_KS8695_CONSOLE", NULL },
    { "CONFIG_KS8695_FLASH_AM29LV033C", NULL, OPT_MODULE_EXPAND },
    /* CONFIG_KSFLASH should be removed. */
    { "CONFIG_KSFLASH", NULL, OPT_MODULE_EXPAND },
    
    /* CX8620X */
    { "CONFIG_CX8620X", NULL },
    { "CONFIG_CX8620X_COMMON", NULL, OPT_HC },
    { "CONFIG_CX8620X_COMMON_RGLOADER", NULL },
    { "CONFIG_CX8620X_SDRAM_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_ARCH_CX8620X", NULL },
    { "CONFIG_CX8620X_FLASH_TE28F160C3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CX8620X_FLASH_TE28F320C3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CX8620X_FLASH_TE28F640C3", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CX8620X_SWITCH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_CX8620X_EHCI", NULL },
	
    { "CONFIG_BCM963XX_BOOTSTRAP", NULL },
    { "CONFIG_VTAG_ICACHE", NULL },
    { "CONFIG_CPU_HAS_PREFETCH", NULL },
    { "CONFIG_CPU_HAS_SYNC", NULL },
    { "CONFIG_NEW_TIME_C", NULL },
    { "CONFIG_NEW_IRQ", NULL },
    { "CONFIG_CPU_HAS_LLSC", NULL },
    { "CONFIG_HOTPLUG", NULL, OPT_HC },
    { "CONFIG_PCMCIA_BCM4710", NULL },
    { "CONFIG_MTD_CFI_ADV_OPTIONS", NULL },
    { "CONFIG_MTD_CFI_NOSWAP", NULL },
    { "CONFIG_MTD_CFI_GEOMETRY", NULL },
    { "CONFIG_MTD_CFI_B2", NULL },
    { "CONFIG_MTD_CFI_I1", NULL },
    { "CONFIG_MTD_CFI_AMDSTD", NULL },
    { "CONFIG_MTD_BCM947XX", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_MTD_XG1000", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_IL_47XX", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_WL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_WL_AP", NULL },
    { "CONFIG_HERMES", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_PCMCIA_HERMES", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RAMFS", NULL },
    { "CONFIG_PARTITION_ADVANCED", NULL },
    { "CONFIG_BCM947", NULL },
    { "CONFIG_MTD_IXP425", NULL },
    { "CONFIG_MNG_SHOW", NULL },
    { "CONFIG_MODULES", NULL },
    { "CONFIG_MPC850", NULL },
    { "CONFIG_MTD", NULL },
    { "CONFIG_MTD_BLOCK", NULL },
    { "CONFIG_MTD_CFI", NULL },
    { "CONFIG_MTD_CFI_INTELEXT", NULL },
    { "CONFIG_MTD_CHAR", NULL },
    { "CONFIG_MTD_CONCAT", NULL },
    { "CONFIG_MTD_GEN_PROBE", NULL },
    { "CONFIG_MTD_PARTITIONS", NULL },
    { "CONFIG_MTD_REDBOOT_PARTS", NULL, OPT_NOSTRIP },
    { "CONFIG_MTD_PHYSMAP", NULL },

    /* Define a simple flash structure for MTD (No need for a special module */
    { "CONFIG_MTD_PHYSMAP_START", NULL, OPT_NUMBER },
    { "CONFIG_MTD_PHYSMAP_LEN", NULL, OPT_NUMBER },
    { "CONFIG_MTD_PHYSMAP_BUSWIDTH", NULL, OPT_NUMBER },
    { "CONFIG_MTD_ROM", NULL },
    
    { "CONFIG_NATSEMI", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_NE2000", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_NE2000_DEV", NULL },
    { "CONFIG_NE2K_PCI", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_NET", NULL },
    { "CONFIG_NETDEVICES", NULL },
    { "CONFIG_NET_EISA", NULL },
    { "CONFIG_NET_ETHERNET", NULL },
    { "CONFIG_NETIF_EXT", NULL },
    { "CONFIG_NETIF_INT", NULL },
    { "CONFIG_NET_ISA", NULL },
    { "CONFIG_NET_PCI", NULL },
    { "CONFIG_NETLINK_DEV", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_NET_RADIO", NULL },
    { "CONFIG_NET_WIRELESS", NULL, OPT_HC },
    { "CONFIG_NFS_FS", NULL },
    { "CONFIG_NOMMU_PAGECACHE_THRESHOLD", NULL },
    { "CONFIG_NO_NAT", NULL },
    { "CONFIG_NO_PGT_CACHE", NULL },
    { "CONFIG_NO_REMOVABLE_IDE", NULL },
    { "CONFIG_NO_UNALIGNED_ACCESS", NULL },
    { "CONFIG_NO_UART2", NULL },
    { "CONFIG_OPENRG", NULL },
    { "CONFIG_PACKET", NULL },
    { "CONFIG_PARIDE_PARPORT", NULL },
    { "CONFIG_PCF8594C2", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_PCI", NULL },
    { "CONFIG_PCI_BIOS", NULL },
    { "CONFIG_PCI_DIRECT", NULL },
    { "CONFIG_PCI_GOANY", NULL },
    { "CONFIG_PCI_NAMES", NULL },
    { "CONFIG_PCI_OLD_PROC", NULL },
    { "CONFIG_PCI_QUIRKS", NULL },
    { "CONFIG_NEW_PCI", NULL },
    { "CONFIG_PCI_AUTO", NULL },
    { "CONFIG_SWAP_IO_SPACE", NULL },
    { "CONFIG_SWAP_IO_SPACE_L", NULL },
    { "CONFIG_SWAP_IO_SPACE_W", NULL },
    { "MAX_DMA_ADDRESS", NULL },
    { "IO_SPACE_LIMIT", NULL },
    { "CONFIG_PCMCIA_DEVELOPMENT", NULL, OPT_HC },
    { "CONFIG_PCNET32", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_PHY_KS8721", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_CX11656", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_KS8737", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_KS8995E", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_KS8995M", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_MARVEL", NULL, OPT_NOSTRIP },
    { "CONFIG_PHY_RTL8201", NULL, OPT_NOSTRIP },
    { "CONFIG_PLUTO_DEBUG", NULL },
    { "CONFIG_PM", NULL },
    /* VPN PPTP */
    { "CONFIG_RG_PPTPS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "PPTP Server" },
    { "CONFIG_PPC", NULL, OPT_HC },
    /* PPP Module */
    { "CONFIG_RG_PPP", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP | OPT_HC,
	"Basic PPP Support" },
    { "CONFIG_RG_PPP_BSDCOMP", NULL, OPT_HC },
    { "CONFIG_RG_PPP_DEFLATE", NULL, OPT_HC },
    /* New PPP connection will be created as PPP on demand */
    { "CONFIG_RG_PPP_ON_DEMAND_AS_DEFAULT", NULL, OPT_HC },
    /* The default maximum idle time of PPP on demand connection */
    { "CONFIG_RG_PPP_ON_DEMAND_DEFAULT_MAX_IDLE_TIME", NULL,
	OPT_HC | OPT_NUMBER },
    /* New PPP connection has BSD compression turned on */
    { "CONFIG_RG_PPP_DEFAULT_BSD_COMPRESSION", NULL, OPT_HC | OPT_NUMBER },
    /* New PPP connection has Deflate compression turned on */
    { "CONFIG_RG_PPP_DEFAULT_DEFLATE_COMPRESSION", NULL, OPT_HC | OPT_NUMBER },

    /* VPN PPTP */
    { "CONFIG_RG_PPP_MPPE", NULL, OPT_HC },
    { "CONFIG_RG_PPPOA", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP |
	OPT_MAJOR_FEATURE, "PPP Over ATM" },
    /* PPP Module */
    { "CONFIG_RG_PPPOE", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"PPP Over Ethernet" },
    { "CONFIG_RG_PPPOES", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"PPP Over Ethernet Server" },
    { "CONFIG_RG_PPPOS", NULL, OPT_MAJOR_FEATURE, "PPP Over Serial" },
    { "CONFIG_RG_PPPOS_CLI", NULL, OPT_HC, "PPP and CLI Over Serial" },
    { "CONFIG_RG_SERIAL", NULL, OPT_NONE, "Serial support for PPPOS" },
    { "CONFIG_RG_HSS", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"PPP Over HSS (T1/E1)" },
    /* IPv6 Module */
    { "CONFIG_RG_IPV6", NULL, OPT_MAJOR_FEATURE | OPT_HC, "IPv6" },
    { "CONFIG_RG_PPTP", NULL, OPT_HC },
    /* VPN PPTP */
    { "CONFIG_RG_PPTPC", NULL, OPT_MAJOR_FEATURE | OPT_HC, "PPTP Client" },
    /* VPN L2TP */
    { "CONFIG_RG_L2TPC", NULL, OPT_MAJOR_FEATURE | OPT_HC, "L2TP Client" },
    { "CONFIG_RG_PPTP_ECHO_INTERVAL", NULL },
    { "CONFIG_RG_PPTP_ECHO_FAILURE", NULL },
    { "CONFIG_PPPOE_RETRANSMIT", NULL },
    { "CONFIG_PPPOE_MAX_RETRANSMIT_TIMEOUT", NULL },
    { "CONFIG_PRISM2_PCI", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_PRISM2_LOAD_FIRMWARE", NULL },
    { "CONFIG_PROC_FS", NULL },
    { "CONFIG_RAMDISK_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_RAM_LIMIT", NULL },
    { "CONFIG_RELEASE", NULL },
    { "CONFIG_RELEASE_COMMON", NULL },
    { "CONFIG_RG_ALG", NULL },
    { "CONFIG_RG_ALG_ICMP", NULL, OPT_MAJOR_FEATURE, "ICMP ALG" },
    { "CONFIG_RG_ALG_PORT_TRIGGER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Port trigger (TFTP) ALG" },
    { "CONFIG_RG_ALG_FTP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "FTP/FTPS ALG" },
    { "CONFIG_RG_ALG_RTSP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"QuickTime/RealAudio/RealPlayer (RTSP) ALG" },
    { "CONFIG_RG_ALG_H323", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"H323 ALG (Netmeeting, CuSeeMe ...)" },
    { "CONFIG_RG_ALG_SIP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "SIP ALG" },
    { "CONFIG_RG_ALG_MGCP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "MGCP ALG" },
    { "CONFIG_RG_ALG_PPTP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"PPTP Client (multiuser) ALG" },
    { "CONFIG_RG_ALG_MSNMS", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Microsoft Network Messenger/Windows Messenger ALG" },
    { "CONFIG_RG_ALG_IPSEC", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"IPSec (multiuser) ALG" },
    { "CONFIG_RG_ALG_L2TP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "L2TP ALG" },
    { "CONFIG_RG_ALG_AIM", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"AOL Instant Messenger ALG" },
    { "CONFIG_RG_ALG_DNS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DNS ALG" },
    { "CONFIG_RG_ALG_DHCP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DHCP ALG" },
    { "CONFIG_RG_ALG_USERSPACE", NULL, OPT_HC },
    /* image includes bootstrap code - the code which initializes hardware.
     * Used for RGloader or distributions without bootloader */
    { "CONFIG_RG_BOOTSTRAP", NULL },
    { "CONFIG_RG_BOOTLDR_REDBOOT", NULL },
    { "CONFIG_RG_BRIDGE", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP |
	OPT_MAJOR_FEATURE | OPT_HC, "Bridge" },
    { "CONFIG_RG_VLAN_BRIDGE", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"VLAN 802.1Q bridge"},  
    { "CONFIG_RG_8021Q_IF", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"VLAN 802.1Q interfaces management"},  
    { "CONFIG_RG_CABLEHOME", NULL, OPT_HC }, 
    { "CONFIG_RG_CABLEHOME_10", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"CableHome 1.0" }, 
    /* Cablehome */
    { "CONFIG_RG_CABLEHOME_11", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"CableHome 1.1" }, 
    /* Cablehome */
    { "CONFIG_RG_CABLEHOME_EMBEDDED", NULL, OPT_HC }, 
    { "CONFIG_RG_CABLEHOME_FULL_WBM", NULL, OPT_HC }, 
    { "CONFIG_RG_DSL_CH", NULL, OPT_HC },
    { "CONFIG_RG_CH_FW", NULL, OPT_HC }, 
    { "CONFIG_RG_CH_EVT_RPT", NULL, OPT_HC }, 
    { "CABLEHOME_TEP_BUG", NULL }, 
    { "CONFIG_RG_CHRDEV", NULL },
    { "CONFIG_RG_CHWAN", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP }, 
    { "CONFIG_RG_USFS", NULL, OPT_MODULE_EXPAND  | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_RG_PPPOE_RELAY", NULL, OPT_MODULE_EXPAND  | OPT_HC |
	OPT_STATIC_ON_DEVELOP | OPT_MAJOR_FEATURE, "PPPoE Relay" },
    { "CONFIG_RG_BROUTE", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_RG_DISPLAY_MSG", NULL },
    { "CONFIG_RG_ELVIS", NULL, OPT_HC },
    /* DSLHome */
    { "CONFIG_RG_DSLHOME", NULL, OPT_HC },

    /* TR-069 Vouchers support */
    { "CONFIG_RG_DSLHOME_VOUCHERS", NULL, OPT_HC },

    /* XML security library needed for TR-069 vouchers */
    { "CONFIG_RG_XMLSEC", NULL, OPT_HC },

    /* XML2 library needed for XML security library */
    { "CONFIG_RG_XML2", NULL, OPT_HC },
    
    /* Firewall and Security Module */
    { "CONFIG_RG_FIREWALL", NULL, OPT_HC },
    { "CONFIG_RG_FW_ICSA", NULL, OPT_HC },
    { "CONFIG_RG_FTP_CLIENT", NULL, OPT_MAJOR_FEATURE, "FTP Client" },
    { "CONFIG_RG_GDBSERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC, "GDB Server" },
    { "CONFIG_RG_HAVE_VENDOR_SRC", NULL },
    { "CONFIG_RG_ADV_SERVICES", NULL, OPT_HC},
    /* Zero Configuration Networking */
    { "CONFIG_RG_IGD", NULL },
    { "CONFIG_RG_IGD_XBOX", NULL, OPT_HC },
    { "CONFIG_RG_XBOX_CERT", NULL, OPT_HC },
    { "CONFIG_RG_IGMP_PROXY", NULL, OPT_MODULE_EXPAND | OPT_HC |
	OPT_STATIC_ON_DEVELOP | OPT_MAJOR_FEATURE, "IGMP Proxy" },
    { "CONFIG_RG_MCAST_RELAY", NULL, OPT_MODULE_EXPAND | OPT_HC |
	OPT_STATIC_ON_DEVELOP | OPT_MAJOR_FEATURE, "Multicast Relay" },
    { "CONFIG_RG_JFW", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP |
	OPT_MAJOR_FEATURE, "JFirewall" },
    { "CONFIG_RG_MSS", NULL, OPT_MODULE_EXPAND | OPT_HC},
    { "CONFIG_RG_IPOA", NULL },
    { "CONFIG_RG_KGDB", NULL, OPT_NOSTRIP },
    { "CONFIG_RG_LAN_UPGRADE", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Remote Upgrade from LAN" },
    { "CONFIG_RG_OS_LINUX", NULL },
    { "CONFIG_RG_OS_ECOS", NULL },
    { "CONFIG_RG_OS_VXWORKS", NULL, OPT_HC },
    { "CONFIG_RG_NAT", NULL, OPT_MAJOR_FEATURE | OPT_HC, "NAT" },
    { "CONFIG_RG_NETKIT", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Netkit Telnet server" },
    { "CONFIG_RG_NETTOOLS_ARP", NULL, OPT_HC },
    { "CONFIG_RG_OPENSSL", NULL, OPT_NONE, "OpenSSL's ssl library" },
    { "CONFIG_RG_CRYPTO", NULL, OPT_HC, "OpenSSL's crypto library" },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_RG_SSL", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Secure HTTP (SSL)" },
    { "CONFIG_RG_PERM_STORAGE", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Permanent Storage"},
    { "CONFIG_RG_ONE_MODULE", NULL, OPT_MODULE_EXPAND | OPT_HC},
    { "CONFIG_RG_KOS", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP |
	OPT_HC},
    { "CONFIG_RG_KOS_KNET", NULL, OPT_HC },
    { "CONFIG_RG_IPV4", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },   
    /* Advanced Routing */
    { "CONFIG_RG_RIP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "RIP V1/V2" },
    { "CONFIG_RG_RMT_UPDATE", NULL, OPT_HC },
    { "CONFIG_RG_RMT_UPGRADE_IMG_IN_MEM", NULL, OPT_NOSTRIP | OPT_HC },
    /* Firewall and Security Module */
    { "CONFIG_RG_RNAT", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Reverse NAT" },
    { "CONFIG_BIDIR_NAT", NULL, OPT_HC },
    { "CONFIG_RG_RNDIS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_RMT_FW_CONF", NULL },
    { "CONFIG_RG_STANDALONE_PS", NULL, OPT_HC },
    { "CONFIG_RG_SYSINIT", NULL },
    { "CONFIG_RG_SYSLOG_REMOTE", NULL, OPT_HC },
    { "CONFIG_RG_TFTP_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Remote Upgrade using TFTP Server"  },
    { "CONFIG_RG_TFTP_SERVER_PASSWORD", NULL, OPT_HC,
	"Verify TFTP password (non-standard)" },
    { "CONFIG_RG_TFTP_UPGRADE", NULL },
    /* SNMP Module */
    { "CONFIG_RG_UCD_SNMP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "SNMP v1/v2" },
    /* SNMP Module */
    { "CONFIG_RG_UCD_SNMP_V3", NULL, OPT_MAJOR_FEATURE, "SNMP v3" },
    { "CONFIG_RG_UPNP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Universal Plug & Play" },
    { "CONFIG_RG_USB_SLAVE", NULL, OPT_MODULE_EXPAND | OPT_HC},
    { "CONFIG_RG_WAN_UPGRADE", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Remote Upgrade from WAN" },
    /* XXX Remove next CONFIG and use device capabilities instead when B3267 is
     * resolved */
    { "CONFIG_RG_WLAN_AUTO_CHANNEL_SELECT", NULL, OPT_HC },
    { "CONFIG_RG_WLAN_SUPPORT", NULL, OPT_HC },
    { "CONFIG_RG_RMT_UPD_LOW_MEM", NULL, OPT_HC },
    { "CONFIG_RG_DNS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DNS" },
    /* Advanced Routing */
    { "CONFIG_RG_DNS_CONCURRENT", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Concurrent DNS query" },
    /* Advanced Routing */
    { "CONFIG_RG_DNS_ROUTE", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DNS Router."
	" Add route rules according to which dns server answare queries" },
    /* Depends on CONFIG_RG_DNS_ROUTE  */
    { "CONFIG_RG_DNS_DOMAIN_ROUTING", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Domain routing. Route according to domains listed on a device" },
    { "CONFIG_RG_DDNS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Dynamic DNS" },

    /* Advanced Management (Graphical Map) */
    { "CONFIG_RG_ENTFY", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Email Notification" },
    /* Transparent proxies */
    { "CONFIG_RG_HTTP_PROXY", NULL, OPT_MAJOR_FEATURE | OPT_HC, "HTTP Proxy" },
    { "CONFIG_RG_GENERIC_PROXY", NULL, OPT_MAJOR_FEATURE, "Generic Proxy" },
    /* Mail filtering proxy */
    { "CONFIG_RG_MAIL_FILTER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Mail filter" },
    /* URL Filtering (Parental Control) */
    { "CONFIG_RG_URL_KEYWORD_FILTER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"URL Keyword Filtering"},
    /* URL Filtering (Parental Control) */
    { "CONFIG_RG_SURFCONTROL", NULL, OPT_MAJOR_FEATURE | OPT_HC, "SurfControl" },
    { "CONFIG_RG_SURFCONTROL_PARTNER_ID", NULL, OPT_NUMBER },
    { "CONFIG_RG_8021X", NULL, OPT_MAJOR_FEATURE | OPT_HC, "802.1X" },
    { "CONFIG_RG_8021X_MD5", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"802.1X MD5 - Internal Authentication" },
    { "CONFIG_RG_8021X_TTLS", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"802.1X TTLS - Internal Authentication" },
    { "CONFIG_RG_8021X_PKTFIL", NULL, 
	OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_RG_8021X_TLS", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"802.1X TLS - Internal Authentication" },
    { "CONFIG_RG_8021X_RADIUS", NULL, OPT_HC },
    /* WLAN and Advanced WLAN Security Module */
    { "CONFIG_RG_8021X_WBM", NULL, OPT_HC },
    /* WLAN and Advanced WLAN Security Module */
    { "CONFIG_RG_RADIUS", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"RADIUS - External Authentication" },
    /* Radius, WPA and 8021x are implemented in the HW or driver of thw WLAN */
    { "CONFIG_RG_VENDOR_WLAN_SEC", NULL },
    /* Having a Radius pages does not mean we have our radius package. There are
     * some wireless devices that support Radius without the package, hence the
     * special CONFIG_RG_RADIUS_WBM flag */
    { "CONFIG_RG_RADIUS_WBM", NULL, OPT_HC },
    { "CONFIG_RG_AUTH", NULL, OPT_HC | OPT_MK },
    { "CONFIG_RG_SSID_NAME", NULL, OPT_C_STR },
    /* Radius settings appears in the connection settings of the wireless
     * connection and NOT in the advanced page. Do not use this by default. */
    { "CONFIG_RG_RADIUS_IN_CONN", NULL, OPT_HC },
    { "CONFIG_RG_RADIUS_LOGIN_AUTH", NULL, OPT_HC, 
	"RADIUS Authentication for TELNET and WBM" },
    /* WLAN and Advanced WLAN Security Module */
    { "CONFIG_RG_WEP", NULL, OPT_MAJOR_FEATURE, "WEP" },
    { "CONFIG_RG_WPA", NULL, OPT_MAJOR_FEATURE | OPT_HC, "WPA" },
    { "CONFIG_RG_WPA_BCM", NULL, OPT_HC },
    { "CONFIG_RG_WPA_WBM", NULL, OPT_HC },
    { "CONFIG_RG_DHCPS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DHCP Server"},
    { "CONFIG_RG_DHCPC", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DHCP Client"},
    /* SOHO / SME Module */
    { "CONFIG_RG_DHCPR", NULL, OPT_MAJOR_FEATURE | OPT_HC, "DHCP Relay Agent"},
    { "CONFIG_RG_DHCP_PKTFIL", NULL, 
	OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_RG_PKTCBL", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_RG_SSI", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Static HTML Management"},
    { "CONFIG_RG_SSI_PAGES", NULL, OPT_HC,
        "Sample Static HTML Management Pages"},
    { "CONFIG_RG_WBM", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Web Based Management"},
    { "CONFIG_RG_TCPDUMP", NULL, OPT_MK | OPT_HC},
    { "CONFIG_FREESWAN_COMMON", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_ACL", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_ATTR", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_BACKUP", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_BOOTLDR", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_CABLEHOME_COMMON", NULL, OPT_HC },
    { "CONFIG_RG_DHCP_COMMON", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_SAMPLES_COMMON", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_DOSFSTOOLS ", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_E2FSPROGS", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_FLEX", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_LIBPCAP", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_LZMA", NULL, OPT_HC },
    { "CONFIG_RG_MGT", NULL, OPT_HC },
    { "CONFIG_RG_OPENSSL_COMMON", NULL, OPT_HC },
    { "CONFIG_RG_READLINE", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_RGLOADER_COMMON", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_STAR", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_SYSLOG_COMMON", NULL, OPT_HC },
    { "CONFIG_RG_TERMCAP", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_TEST_TOOLS", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_TZ", NULL, OPT_HC },
    { "CONFIG_RG_USAGI", NULL, OPT_MK | OPT_HC},
    { "CONFIG_RG_UTIL_LINUX", NULL, OPT_MK | OPT_HC},
    { "CONFIG_GUI_RG", NULL, OPT_THEME | OPT_HC},
    { "CONFIG_GUI_LINKSYS", NULL, OPT_THEME },
    { "CONFIG_GUI_SOHOWARE", NULL, OPT_THEME },
    { "CONFIG_GUI_NETGEAR", NULL, OPT_THEME },
    { "CONFIG_GUI_ARRIS", NULL, OPT_THEME },
    { "CONFIG_GUI_WELLTECH", NULL, OPT_THEME },
    { "CONFIG_GUI_BELKIN", NULL, OPT_THEME | OPT_HC },
    { "CONFIG_GUI_ACTIONTEC", NULL, OPT_THEME | OPT_HC}, 
    { "CONFIG_FOR_VERIZON", NULL, OPT_HC },
    { "CONFIG_FOR_QWEST", NULL, OPT_HC },
    { "CONFIG_RG_FIRMWARE_RESTORE", NULL, OPT_HC },
    { "CONFIG_RG_ACTIVE_WAN", NULL, OPT_HC },
    { "CONFIG_RG_AUTO_WAN_DETECTION", NULL, OPT_HC },
    { "CONFIG_RG_WBM_ADV_FILT", NULL }, 
    { "CONFIG_RG_LIBIMAGE", NULL, OPT_HC },
    { "CONFIG_RG_LIBIMAGE_DIM", NULL, OPT_HC },
    { "CONFIG_RG_LIBJPEG", NULL, OPT_HC },
    { "CONFIG_RG_NETOBJ", NULL, OPT_HC },
    { "CONFIG_RG_LAN_BRIDGE_CONST", NULL, OPT_HC },
    { "CONFIG_RG_AUTO_DST", NULL, OPT_HC },
    { "CONFIG_RG_TZ_COMMON", NULL, OPT_MAJOR_FEATURE, "TimeZone support" },
    { "CONFIG_RG_TZ_FULL", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Full TimeZone support" },
    { "CONFIG_RG_TZ_YEARS", NULL, OPT_NUMBER },
    { "CONFIG_RG_HTTPS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "HTTP Server"},
    { "CONFIG_HTTP_CGI_PROCESS", NULL, OPT_HC },
    { "CONFIG_RG_SAMPLES", NULL },
    { "CONFIG_RG_TELNETS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Telnet Server" },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_RG_SYSLOG", NULL, OPT_MAJOR_FEATURE | OPT_HC, "SysLog" },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_RG_LOG_DEV", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    /* Advanced Management (Graphical Map) */
    { "CONFIG_RG_KERN_LOG", NULL },
    /* Size of syslog buffer for use in the kernel */
    { "CONFIG_RG_LOG_DEV_BUF_SIZE", NULL, OPT_NUMBER },
    /* Size of syslog buffer for Firewall log messages */
    { "CONFIG_RG_SYSLOG_FW_DEF_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_RG_CLI", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Command Line Interface" },
    { "CONFIG_RG_CLI_SERVER", NULL },
    { "CONFIG_RG_CLI_SERIAL", NULL },
    { "CONFIG_RG_TTYP", NULL },
    { "CONFIG_RG_LOGIN", NULL },
    /* Advanced Routing */
    { "CONFIG_RG_STATIC_ROUTE", NULL, OPT_HC },
    { "CONFIG_RG_BUSYBOX", NULL, OPT_HC },
    { "CONFIG_RG_ERESOLV", NULL },
    { "CONFIG_RG_WGET", NULL, OPT_HC },
    /* Assign only non-routable IP addresses to the LAN device */
    { "CONFIG_RG_NON_ROUTABLE_LAN_DEVICE_IP", NULL, OPT_HC },
    { "CONFIG_RG_FREESWAN", NULL, OPT_HC },
    { "CONFIG_RG_X509", NULL, OPT_HC },
    { "CONFIG_RG_CERT", NULL, OPT_HC },
    { "CONFIG_RG_KERBEROS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Kerberos" },
    { "CONFIG_RGLOADER_CLI", NULL },
    { "CONFIG_ROOT_ON_FLASH", NULL },
    { "CONFIG_RTC", NULL },
    { "CONFIG_RTL8139", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RWSEM_GENERIC_SPINLOCK", NULL },
    { "CONFIG_SCC2_ENET", NULL },
    { "CONFIG_SCC_ENET", NULL },
    { "CONFIG_SDRAM_BASE", NULL },
    { "CONFIG_SDRAM_END", NULL },
    /* The SDRAM size given to Linux for memory initialization. */
    { "CONFIG_SDRAM_SIZE", NULL, OPT_NUMBER | OPT_HC},
    { "CONFIG_PHYS_SDRAM_SIZE", NULL },
    { "CONFIG_SERIAL", NULL },
    { "CONFIG_SERIAL_CORE", NULL },
    { "CONFIG_SERIAL_CORE_CONSOLE", NULL },
    { "CONFIG_SERIAL_CNXT", NULL },
    { "CONFIG_SERIAL_CONSOLE", NULL },
    { "CONFIG_SERIAL_ECHO", NULL },
    { "CONFIG_SERIAL_IXP", NULL },
    { "CONFIG_SIMPLE_RAMDISK", NULL },
    { "CONFIG_SKB_LARGE", NULL },
    { "CONFIG_SMALL_FLASH", NULL },
    { "CONFIG_SMALL_SDRAM", NULL },
    { "CONFIG_SMALL_STACK", NULL },
    { "CONFIG_SOFT_FLOAT", NULL },
    { "CONFIG_SOFTSAR_SMALL_BUFFERS", NULL },
    { "CONFIG_SP_RAM_POS", NULL },
    { "CONFIG_SP_RAM_SIZE", NULL },
    { "CONFIG_START_KERNEL_POS", NULL },
    { "CONFIG_STRONGARM", NULL },
    { "CONFIG_SUNRPC", NULL },
    { "CONFIG_SYN_COOKIES", NULL },
    { "CONFIG_SYSCTL", NULL },
    { "CONFIG_SYSLOG_UNIXSOCK_SUPPORT", NULL },
    { "CONFIG_SYSVIPC", NULL },
    { "CONFIG_TEST_TOOLS_PING", NULL },
    { "CONFIG_TEST_TOOLS_CONN_SPEED", NULL },
    { "CONFIG_TEXT_SECTIONS", NULL },
    /* Firewall and Security Module */
    { "CONFIG_RG_TODC", NULL, OPT_MAJOR_FEATURE | OPT_HC, "TOD Client" },
    { "CONFIG_UCD_SNMP_AGENT_LIB", NULL },
    { "CONFIG_UCD_SNMP_NO_DEF_MIBS", NULL },
    { "CONFIG_UID16", NULL },
    { "CONFIG_ULIBC", NULL, OPT_HC },
    { "CONFIG_UNIX", NULL },
    { "CONFIG_UNIX98_PTY_COUNT", NULL, OPT_NUMBER },
    { "CONFIG_UNIX98_PTYS", NULL },
    { "CONFIG_USB", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_USB", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_USB_OV511", NULL },
    { "CONFIG_VIDEO_DEV", NULL },
    { "CONFIG_VIDEO_PROC_FS", NULL },
    { "CONFIG_USB_PWC", NULL },
    { "CONFIG_USB_SPCA5XX", NULL},
    { "CONFIG_FILESERVER_KERNEL_CONFIG", NULL },
    { "CONFIG_USB_STORAGE", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_USB_DEVICEFS", NULL },
    { "CONFIG_USB_OHCI", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_USB_UHCI", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_USB_EHCI_HCD", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_USB_CONN_MONITOR", NULL },
    { "CONFIG_USB_RNDIS", NULL, OPT_MODULE_EXPAND | OPT_MAJOR_FEATURE,
	"USB RNDIS" },
    { "OPENRG_DEBUG_MODULES", NULL },
    { "CONFIG_USB_SIMPLE_DMA", NULL },
    { "CONFIG_GENERIC_ISA_DMA", NULL },
    { "CONFIG_INSURE", NULL },
    { "CONFIG_VALGRIND", NULL, OPT_HC },
    { "CONFIG_VIA_RHINE", NULL },
    { "CONFIG_VPN", NULL },
    { "CONFIG_VT", NULL },
    { "CONFIG_VT_CONSOLE", NULL },
    { "CONFIG_X86", NULL },
    { "CONFIG_X86_L1_CACHE_SHIFT", NULL, OPT_NUMBER },
    { "CONFIG_X86_PPRO_FENCE", NULL },
    { "CONFIG_X86_REMOTE_DEBUG", NULL, OPT_NOSTRIP },
    { "CONFIG_ZBOOT_ROM_TEXT", NULL, OPT_NUMBER },
    { "CONFIG_ZBOOT_ROM_BSS", NULL, OPT_NUMBER },
    { "CONFIG_ZCOM_XG1000", NULL },
    { "CONFIG_ZKERNEL_RAM_POS", NULL },
    { "CONFIG_ZOOM_CM", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_ZRAMDISK_POS", NULL },
    { "CONFIG_PCBOX", NULL, OPT_HC },
    { "TARGET_ENDIANESS", NULL, OPT_STR },
    { "BOARD", NULL, OPT_STR },
    { "CONFIG_IDT_COMMON", NULL },
    { "CONFIG_RG_FLASHDISK", NULL }, /* Flash device is a an IDE device */
    { "FIRM", NULL, OPT_STR }, /* Check if we need it */
    { "MAGIC_ROM_PTR", NULL },
    { "CONFIG_RG_FLASH_LINEAR", NULL },
    { "CONFIG_RG_TELEPHONY", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Telephony" },
    { "CONFIG_RG_VOATM", NULL, OPT_HC },
    { "CONFIG_RG_VOATM_ELCP", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_VOATM_CAS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_PHY_LSI_LOGIC", NULL },
    /* Factory settings */
    { "CONFIG_RG_FACTORY_SETTINGS", NULL, OPT_HC },
    { "CONFIG_RG_VENDOR_FACTORY_SETTINGS", NULL, OPT_HC },
    { "CONFIG_RG_MAC_COMPANY_ID", NULL },
    /* Hardware buttons */
    { "CONFIG_RG_HW_BUTTONS", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "DIST_TYPE", NULL },
    { "CONFIG_REMOTE_DEBUG", NULL, OPT_NOSTRIP }, /* IDT KERNEL DEBUGGER */
    { "CONFIG_PCI_RESET", NULL, OPT_NOSTRIP },
    { "CONFIG_RG_CONSOLE_DEVICE", NULL, OPT_STR }, /* ttyS0/1 */
    { "CONFIG_SAMBA", NULL }, /* to compile pkg/samba */
    { "OPENRG_CHRDEV_MAJOR", NULL, OPT_NUMBER },
    { "OPENRG_CHRDEV_NAME", NULL, OPT_C_STR },
    { "OPENRG_ATA_DEV_MAJOR", NULL, OPT_NUMBER },
    { "OPENRG_ATA_DEV_NAME", NULL },
    { "CONFIG_RG_NOT_UNIX", NULL },
    { "CONFIG_RG_EFSS", NULL },
    { "CONFIG_VX_SYMTBL", NULL },
    { "CONFIG_ATHEROS_AR531X_MIPS", NULL, OPT_HC },
    { "CONFIG_ARCH_AR531X", NULL },
    { "CONFIG_ARCH_WRT108G", NULL, OPT_HC },
    { "CONFIG_AR531X_DEBUG", NULL },
    { "CONFIG_TI_404_MIPS", NULL, OPT_HC },
    { "CONFIG_TI_404_COMMON", NULL, OPT_HC },
    { "CONFIG_TI_404_HAS_QOS_API", NULL },
    { "CONFIG_WINDOWS_HOST", NULL },
    { "CONFIG_GCC_CAN_INLINE", NULL },
    { "CONFIG_GCC_CANNOT_OPTIMIZE", NULL },
    { "RAM_HIGH_ADRS", NULL },
    { "RAM_LOW_ADRS", NULL },
    { "CONFIG_I386_BOCHS", NULL },
    { "CONFIG_I386", NULL, OPT_HC },
    { "CONFIG_UM", NULL, OPT_HC },
    /* For using overriden symbols ether_input and if_start */
    { "CONFIG_VX_KNET_SYMLINK", NULL },
    /* When the following is set to yes on VxWorks platforms, packets are not
     * sent immediately (i.e. from hooks context), but rather accumulated and
     * sent from a different context. This siginifcantly improves performance
     * on Atheros boards and dramatically decreases performance on TI, so be
     * careful when using it. */
    { "CONFIG_RG_VX_DEFERRED_TX", NULL },
    /* File Server */
    { "CONFIG_RG_FILESERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC, "File Server" },
    { "CONFIG_RG_STORAGE", NULL },
    { "CONFIG_RG_STORAGE_UTILS", NULL },
    
    /* Maximum size, in GB, of checkable EXT2 partitions */
    { "CONFIG_RG_MAX_EXT2_CHECK_SIZE", NULL, OPT_NUMBER }, 
    
    /* For large file support of ulibc - needed for samba, used by ulibc only
     * (has no effect when using glibc), does not work for armnommu */
    { "CONFIG_RG_LARGE_FILE_SUPPORT", NULL },
    { "CONFIG_RG_CODEPAGE", NULL, OPT_STR },
    { "CONFIG_EXACT_EVENT_LOOP", NULL },
    /* Linux FS opts to support OpenRG fileserver */
    { "CONFIG_MSDOS_PARTITION", NULL, OPT_NOSTRIP },
    { "CONFIG_FAT_FS" },
    { "CONFIG_MSDOS_FS" },
    { "CONFIG_VFAT_FS" },
    { "CONFIG_NLS" },
    { "CONFIG_NLS_DEFAULT", NULL, OPT_STR },
    { "CONFIG_NLS_CODEPAGE_437" },
    { "CONFIG_NLS_CODEPAGE_850" },
    { "CONFIG_NLS_UTF8" },
    { "CONFIG_SMB_FS" },

    /* ACL support */
    { "CONFIG_RG_FILESERVER_ACLS", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"Posix Access Control Lists (ACLs)" },
    { "CONFIG_RG_FILESERVER_ACLS_DEBUG", NULL, OPT_HC },

    /* ACLs and Extended Attributes kernel config options */
    { "CONFIG_FS_POSIX_ACL", NULL },
    { "CONFIG_EXT3_FS_POSIX_ACL", NULL },
    { "CONFIG_EXT2_FS_POSIX_ACL", NULL },
    { "CONFIG_EXT3_FS_XATTR", NULL },
    { "CONFIG_EXT3_FS_XATTR_SHARING", NULL },
    { "CONFIG_EXT3_FS_XATTR_USER", NULL },
    { "CONFIG_EXT2_FS_XATTR", NULL },
    { "CONFIG_EXT2_FS_XATTR_SHARING", NULL },
    { "CONFIG_EXT2_FS_XATTR_USER", NULL },
    { "CONFIG_FS_MBCACHE", NULL },

    /* RAID support */
    { "CONFIG_RG_RAID", NULL, OPT_MAJOR_FEATURE | OPT_HC, "RAID" },
    { "CONFIG_RG_RAID_IDE_ONLY", NULL, OPT_HC },

    /* Kernel RAID config option */
    { "CONFIG_MD", NULL },
    { "CONFIG_BLK_DEV_MD", NULL },
    { "CONFIG_MD_RAID0", NULL },
    { "CONFIG_MD_RAID1", NULL },

    /* SCSI options to support USB and firewire disks */
    { "CONFIG_SCSI" },
    { "CONFIG_BLK_DEV_SD" },
    { "CONFIG_SD_EXTRA_DEVS", NULL, OPT_NUMBER },
    { "CONFIG_FLASH", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP | OPT_HC},
    { "CONFIG_FLASH_IN_FILE" }, /* The 'flash' is a file in the filesystem */
    /* EMI test IR support for BAMBOO(PCI) */
    { "CONFIG_RG_IR_TEST" },
    /* 802.1Q VLAN interfaces infrastructure */
    { "CONFIG_VLAN_8021Q" }, /* Kernel config - set by the rg one */
    { "CONFIG_RG_VLAN_8021Q", NULL, OPT_HC }, /* RG config */
    /* 802.1Q VLAN fast implementation - has no effect without CONFIG_VLAN_8021Q
     */
    { "CONFIG_VLAN_8021Q_FAST" },
    /* AT93CXX EEPROM support */
    { "CONFIG_AT93CXX", NULL, OPT_MODULE_EXPAND },
    /* ADM6996 Switch + Vlans support */
    { "CONFIG_ADM6996", NULL, OPT_MODULE_EXPAND  },
    /* Debugging kernel */
    { "CONFIG_NO_FRAME_POINTER" },
    { "CONFIG_RG_OS_LINUX_24", NULL, OPT_HC },
    { "CONFIG_RG_OS_LINUX_22", NULL, OPT_HC },
    { "CONFIG_RG_EMI", NULL, OPT_HC },
    { "CONFIG_RG_EMI_IRDA", NULL, OPT_HC },
    { "CONFIG_RG_EMI_USB", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_LANGUAGES", NULL, OPT_STR },
    { "CONFIG_RG_DIST_LANG", NULL, OPT_STR },
    
    /* Infineon Amazon */
    { "CONFIG_INFINEON_AMAZON", NULL, OPT_HC },
    { "CONFIG_AMAZON", NULL },
    { "CONFIG_AMAZON_PCI", NULL },
    { "CONFIG_AMAZON_PCI_HW_SWAP", NULL },
    { "CONFIG_ATM_AMAZON", NULL },
    { "CONFIG_ATM_BONDING_SM", NULL },
    { "CONFIG_ATM_BONDING_AWARE_ASM", NULL },
    { "CONFIG_IFX_ATM_OAM", NULL },
    { "CONFIG_AMAZON_SWITCH_ACCESS", NULL },
    { "CONFIG_AMAZON_SWITCH_HASH", NULL },
    { "CONFIG_AMAZON_ETHERNET", NULL },
    { "CONFIG_AMAZON_SWITCH_CONTROL", NULL },
    { "CONFIG_AMAZON_PSEUDO_LAN", NULL },
    { "CONFIG_ADM6996_SUPPORT", NULL },
    { "CONFIG_SWITCH_ADM6996LC", NULL },
    { "CONFIG_SWITCH_ADM6996_EEPROM", NULL },
    { "CONFIG_SWITCH_ADM6996_MDIO", NULL },
    { "CONFIG_IFX_NFEXT_AMAZON_SWITCH_PHYPORT", NULL },
    { "CONFIG_SERIAL_AMAZONASC", NULL },
    { "CONFIG_SERIAL_AMAZONASC_CONSOLE", NULL },
    { "CONFIG_AMAZONASC_DEFAULT_BAUDRATE", NULL, OPT_NUMBER },
    { "CONFIG_AMAZON_SSC", NULL },
    { "CONFIG_AMAZON_WDT", NULL },
    { "CONFIG_AMAZON_MEI", NULL },
    { "CONFIG_ARCH_AMAZON_BA214WG", NULL },
    { "CONFIG_BA214WG_REV30" },

    /* UML options */
    { "CONFIG_RG_UML", NULL, OPT_HC },
    { "CONFIG_PROC_MM" },
    { "CONFIG_KERNEL_HALF_GIGS", NULL, OPT_NUMBER },
    { "CONFIG_CON_ZERO_CHAN", NULL, OPT_C_STR },
    { "CONFIG_NEST_LEVEL", NULL, OPT_NUMBER },
    { "CONFIG_KERNEL_STACK_ORDER", NULL, OPT_NUMBER },
    { "CONFIG_MCONSOLE" },
    { "CONFIG_HPPFS" },
    { "CONFIG_HOSTFS" },
    { "CONFIG_MODE_TT" },
    { "CONFIG_MODE_SKAS" },
    { "CONFIG_CON_CHAN", NULL, OPT_C_STR },
    { "CONFIG_SSL_CHAN", NULL, OPT_C_STR },
    { "CONFIG_PT_PROXY" },
    { "CONFIG_USERMODE" },
    { "CONFIG_RWSEM_XCHGADD_ALGORITHM" },
    { "CONFIG_STDIO_CONSOLE" },
    { "CONFIG_SSL" },
    { "CONFIG_FD_CHAN" },
    { "CONFIG_NULL_CHAN" },
    { "CONFIG_PORT_CHAN" },
    { "CONFIG_PTY_CHAN" },
    { "CONFIG_TTY_CHAN" },
    { "CONFIG_XTERM_CHAN" },
    { "CONFIG_BLK_DEV_UBD" },
    { "CONFIG_BLK_DEV_NBD" },
    { "CONFIG_UML_NET" },
    { "CONFIG_UML_NET_ETHERTAP" },
    { "CONFIG_UML_NET_TUNTAP" },
    { "CONFIG_UML_NET_SLIP" },
    { "CONFIG_UML_NET_SLIRP" },
    { "CONFIG_UML_NET_DAEMON" },
    { "CONFIG_UML_NET_MCAST" },
    { "CONFIG_UML_RAM_SIZE", NULL, OPT_C_STR },
    { "CONFIG_UML_BIG_FLASH" }, /* Flash size 50 MB */
    { "CONFIG_DUMMY" }, /* XXX: Needed for UML Need to be checked */
    { "CONFIG_TUN" },
    { "CONFIG_PACKET_MMAP" },
    { "CONFIG_QUOTA" },
    { "CONFIG_AUTOFS4_FS" },
    { "CONFIG_DEVFS_FS" },
    { "CONFIG_DEVFS_MOUNT" },
    { "CONFIG_REISERFS_FS" },
    { "CONFIG_MTD_BLKMTD" },
    { "CONFIG_ZLIB_INFLATE" },
    { "CONFIG_ZLIB_DEFLATE" },
    { "CONFIG_USB_SERIAL", NULL },
    { "CONFIG_USB_SERIAL_PL2303", NULL },
    { "CONFIG_ADSL_CHIP_ALCATEL_20150" },
    { "CONFIG_ADSL_CHIP_ALCATEL_20170" },
    { "CONFIG_RG_PROXY_ARP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Proxy ARP" },
    { "CONFIG_BCM947_HW_BUG_HACK" },
    { "CONFIG_RG_OAM_PING", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"OAM F4/F5 Loopback"  },
    { "CONFIG_STOP_ON_INIT_FAIL", NULL, OPT_HC },
    { "CONFIG_KNSN_SDRAM_16BIT" },
    { "CONFIG_IPV6", NULL },
    { "CONFIG_IPV6_RESTRICTED_DOUBLE_BIND", NULL },
    { "CONFIG_IPV6_RT_DFLT", NULL },
    { "CONFIG_IPV6_6TO4_NEXTHOP", NULL },
    { "CONFIG_RG_KCALL", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_RG_FRAG_CACHE", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    /* disable throttling of tx queue (which drops all rx until tx queue empty)
     */
    { "CONFIG_RG_NET_NO_THROTTLE" },
    { "CONFIG_RG_XML", NULL, OPT_HC },
    /* LAN Driver - USB Host */
    { "CONFIG_WBM_PAGES_EXPIRE", NULL, OPT_HC },
    { "CONFIG_RG_FLASH_LAYOUT_SIZE", NULL, OPT_NUMBER },
    { "CONFIG_LSP_FLASH_LAYOUT", NULL },
    { "CONFIG_RG_AUTOTEST", NULL, OPT_HC }, /* Export autotest in
						     distribution */
    { "CONFIG_RG_DATE", NULL },
    { "CONFIG_RG_PROD_IMG", NULL },
    
    /* OpenRG's programmers guide tutorial */
    { "CONFIG_RG_TUTORIAL", NULL, OPT_NOSTRIP | OPT_HC },
    /* OpenRG's programmer's guide advanced tutorial */
    { "CONFIG_RG_TUTORIAL_ADVANCED", NULL, OPT_NOSTRIP | OPT_HC },

    /* Webcam */
    { "CONFIG_RG_WEBCAM", NULL, OPT_HC },

    /* Zero Configuration options */
    { "CONFIG_ZERO_CONFIGURATION", NULL, OPT_MAJOR_FEATURE, "Zero Configuration Technology" },
    { "CONFIG_ZC_AUTO_LEARNING_DNS", NULL, OPT_MAJOR_FEATURE, "Auto Learning DNS" },
    { "CONFIG_ZC_IP_AUTO_DETECTION", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"IP Auto Detection" },
    { "CONFIG_ZC_AUTO_CONFIG_NON_PNP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Auto Configuration Of Non-PNP Networks" },
    { "CONFIG_ZC_NETWORK_MAP", NULL, OPT_MAJOR_FEATURE, "Network Map" },
    { "CONFIG_ZC_LAYER_3_BRIDGING", NULL, OPT_MAJOR_FEATURE, "Layer 3 Bridging" },

    { "CONFIG_USB_PRINTER" },
    /* Print Server */
    { "CONFIG_RG_PRINT_SERVER_SPOOL", NULL, OPT_NUMBER },
    { "CONFIG_RG_PRINT_SERVER_PRINTER_NULL" },
    /* Print Server */
    { "CONFIG_RG_PRINT_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Print Server" },
    { "CONFIG_RG_SAMBA_PRINTING", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"Microsoft Shared Printing"},
    { "CONFIG_RG_IPP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Internet Printing" },
    { "CONFIG_RG_LPD", NULL, OPT_HC },

    { "CONFIG_RG_LANG", NULL, OPT_HC },
    { "CONFIG_RG_DYN_FLASH_LAYOUT", NULL, OPT_HC },

    { "CONFIG_RG_DNS_USE_ISP_DOMAIN", NULL, OPT_HC },

    /* VxWorks uses TFFS filesystem to store image/configuration */
    { "CONFIG_VX_TFFS" },

    /* VoIP */
    { "CONFIG_RG_VOIP", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Voice Over IP" },
    { "CONFIG_RG_IPPHONE", NULL, OPT_HC }, /* IP phone feature */
    { "CONFIG_RG_ATA", NULL, OPT_HC }, /* Analog Termination Adapter feature */
    /* Audio parameters are configurable via WBM */
    { "CONFIG_RG_AUDIO_MGT", NULL},
    /* VoIP SIP Stack */
    { "CONFIG_RG_VOIP_SIP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"SIP Signalling" },
    /* VoIP H323 Stack */
    { "CONFIG_RG_VOIP_H323", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"H.323 Signalling" },
    /* VoIP MGCP Stack */
    { "CONFIG_RG_VOIP_MGCP", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"MGCP Signalling" },
    { "CONFIG_RG_VOIP_NUMBER_OF_LINES", NULL, OPT_HC | OPT_NUMBER },
    { "CONFIG_RG_VOIP_HW_EMULATION", NULL, OPT_HC },
    /* Make SIP ALG work on traffic of OpenRG's own SIP stack */
    { "CONFIG_RG_VOIP_USE_SIP_ALG", NULL, OPT_HC },

    /* VoIP - RADVISION */
    { "CONFIG_RG_VOIP_RV", NULL, OPT_HC },
    { "CONFIG_RG_VOIP_RV_SIP", NULL, OPT_HC },
    { "CONFIG_RG_VOIP_RV_H323", NULL, OPT_HC },
    { "CONFIG_RG_VOIP_RV_MGCP", NULL, OPT_HC },

    /* VoIP - oSIP */
    { "CONFIG_RG_VOIP_OSIP", NULL, OPT_HC },

    /* VoIP - Asterisk */
    { "CONFIG_RG_VOIP_ASTERISK", NULL, OPT_HC },

    { "CONFIG_RG_RTP", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP | OPT_HC,
	"RTP kernel module" },

    { "CONFIG_WX5715_VLAN_SWITCH_DISABLE" },
    /* kernel EXPORT_SYMBOL's only symbols needed by modules (reduced set) */
    { "CONFIG_RG_KERNEL_NEEDED_SYMBOLS" },
    { "CONFIG_RG_OLD_XSCALE_TOOLCHAIN" },
    { "CONFIG_RG_THREADS" }, /* Set if threads are used by OpenRG or one of the
				running processes */  
    { "CONFIG_RG_OSS_RMT", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"Remote Update Management" },
    { "CONFIG_HITRON_BSP", NULL, OPT_HC }, /* Use Hitron's BSP instead of
					    * TI's
					    */
    { "CONFIG_RG_VX_TIMERS_TASK" }, /* Use a task for running timers instead of 
				       vxWorks timer API */
    { "CONFIG_RG_RMT_MNG", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"Remote Management Server" },
    /* Storlink options */
    { "CONFIG_SL2312_COMMON_RG", NULL },
    { "CONFIG_SL2312_COMMON_RGLOADER", NULL },
    { "CONFIG_SL2312_COMMON", NULL, OPT_HC },
    { "CONFIG_ARCH_SL2312", NULL },
    { "CONFIG_SL2312_ASIC", NULL },
    { "CONFIG_BLK_DEV_IDE_MODES", NULL },
    { "CONFIG_BLK_DEV_SL2312_IDE", NULL },
    { "CONFIG_BLK_DEV_SL2312_IDE_CHANNEL_0", NULL },
    { "CONFIG_BLK_DEV_SL2312_IDE_CHANNEL_1", NULL },
    { "CONFIG_CPU_FA52X", NULL },
    { "CONFIG_CPU_FA52X_I_CACHE_ON", NULL },
    { "CONFIG_CPU_FA52X_D_CACHE_ON", NULL },
    { "CONFIG_CPU_FA52X_WRITETHROUGH", NULL },
    { "CONFIG_SL2312_FLASH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_SERIAL_IT8712", NULL },
    { "CONFIG_SERIAL_IT8712_CONSOLE", NULL },
    { "CONFIG_KERNEL_START", NULL, OPT_STR },
    { "CONFIG_USB_OHCI_SL2312", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_SL2312", NULL },
    { "CONFIG_SL2312_LPC", NULL },
    { "CONFIG_SL2312_LPC_IT8712", NULL },
    { "CONFIG_IT8712_GPIO", NULL },
    { "CONFIG_SL2312_SHARE_PIN", NULL },
    { "CONFIG_SL2312_ETH", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_BINFMT_AOUT", NULL },
    /* End Storlink options */
    { "CONFIG_RG_EVENT_LOGGING", NULL, OPT_MAJOR_FEATURE, "Event Logging"},
    { "CONFIG_RG_WINS_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"WINS Server" },
    { "CONFIG_RG_FTP_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC, "FTP Server" },
    { "CONFIG_RG_MAIL_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC,
	"Mail Server" },
    { "CONFIG_RG_WEB_SERVER", NULL, OPT_MAJOR_FEATURE | OPT_HC, "Web Server" },
    { "CONFIG_RG_FS_BACKUP", NULL, OPT_MAJOR_FEATURE | OPT_HC, 
	"File System Backup and Restore" },
    { "CONFIG_NEW_NONE_PRICED_FEATURES", NULL },
    { "CONFIG_RG_CFG_SERVER", NULL },

    /* Traffic Control options */
    { "CONFIG_TOS_DSCP_RFC2474", NULL, OPT_MODULE_EXPAND,
	"Treat ToS octet according to RFC2474" },
    { "CONFIG_RG_IPROUTE2", NULL, OPT_HC,
	"IPRoute2 user-mode configuration tools" },
    { "CONFIG_RG_QOS", NULL, OPT_MAJOR_FEATURE | OPT_HC, "QoS support" },
    { "CONFIG_RG_QOS_INGRESS", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP,
	"QoS ingress support" },
    { "CONFIG_NET_SCHED", NULL, OPT_MODULE_EXPAND, "QoS and/or fair queueing" },
    { "CONFIG_NET_SCH_INGRESS", NULL, OPT_MODULE_EXPAND, "Ingress qdisc" },
    { "CONFIG_NET_SCH_HTB", NULL, OPT_MODULE_EXPAND, "HTB packet scheduler" },
    { "CONFIG_NET_SCH_ATM", NULL, OPT_MODULE_EXPAND,
	"ATM packet pseudoscheduler" },
    { "CONFIG_NET_SCH_PRIO", NULL, OPT_MODULE_EXPAND,
	"The simplest PRIO pseudoscheduler" },
    { "CONFIG_NET_SCH_RED", NULL, OPT_MODULE_EXPAND,
	"The simplest RED pseudoscheduler" },
    { "CONFIG_NET_SCH_SFQ", NULL, OPT_MODULE_EXPAND,
	"The simplest SFQ pseudoscheduler" },
    { "CONFIG_NET_SCH_DSMARK", NULL, OPT_MODULE_EXPAND,
	"Diffserv field marker" },
    { "CONFIG_NET_QOS", NULL, OPT_MODULE_EXPAND, "QoS support" },
    { "CONFIG_NET_ESTIMATOR", NULL, OPT_MODULE_EXPAND, "Rate estimator" },
    { "CONFIG_NET_CLS", NULL, OPT_MODULE_EXPAND, "Packet classifier API" },
    { "CONFIG_NET_CLS_POLICE", NULL, OPT_MODULE_EXPAND, "Traffic policing" },
    { "CONFIG_NET_CLS_TCINDEX", NULL, OPT_MODULE_EXPAND,
	"TC index classifier" },
    { "CONFIG_NET_CLS_FW", NULL, OPT_MODULE_EXPAND,
	"Firewall based classifier" },
    { "CONFIG_NET_CLS_U32", NULL, OPT_MODULE_EXPAND, "U32 classifier" },
    { "CONFIG_NET_CLS_RSVP", NULL, OPT_MODULE_EXPAND,
	"Special RSVP classifier" },
    { "CONFIG_NET_CLS_RSVP6", NULL, OPT_MODULE_EXPAND,
	"Special RSVP classifier for IPv6" },
    { "CONFIG_IP_ROUTE_MULTIPATH", NULL, OPT_MODULE_EXPAND,
	"Equal cost multipath" },
    { "CONFIG_IP_ROUTE_VERBOSE", NULL, OPT_MODULE_EXPAND,
	"Verbose route monitoring" },
    { "CONFIG_IP_ROUTE_FWMARK", NULL, OPT_MODULE_EXPAND,
	"Use netfilter MARK value as routing key" },

    /* Core features of foundation module. */
    { "CONFIG_RG_FOUNDATION_CORE", NULL },

    /* Build on/for which arch */
    { "CONFIG_RG_TARGET_LINUX", NULL },
    { "CONFIG_RG_TARGET_VXWORKS", NULL },
    { "CONFIG_RG_HOST_CYGWIN", NULL },
    { "CONFIG_RG_WINDOWS_HOST", NULL }, /* backwards compatibility */
    { "CONFIG_RG_HOST_LINUX", NULL },

    { "CONFIG_RG_GPL", NULL},
    { "CONFIG_RG_DO_DEVICES", NULL},

    /* OpenRG Packages */
    { "PACKAGE_OPENRG_BASIC_GATEWAY", NULL },
    { "PACKAGE_OPENRG_SECURITY_GATEWAY", NULL }, 
    { "PACKAGE_OPENRG_VPN_GATEWAY", NULL }, 
    { "PACKAGE_OPENRG_SOHO_GATEWAY", NULL }, 

    /* OpenRG Modules */
    { "MODULE_RG_FOUNDATION", NULL, OPT_MODULE, 
	"Foundation Module (Mandatory)" },
    { "MODULE_RG_ADVANCED_MANAGEMENT", NULL, OPT_MODULE, 
	"Advanced Management (Graphical Map)" },
    { "MODULE_RG_SNMP", NULL, OPT_MODULE, "SNMP Module" },
    { "MODULE_RG_DSL", NULL, OPT_MODULE, "DSL Module (ATM)" },
    { "MODULE_RG_PPP", NULL, OPT_MODULE, "PPP Module" },
    { "MODULE_RG_IPV6", NULL, OPT_MODULE, "IPv6 Module" },
    { "MODULE_RG_VLAN", NULL, OPT_MODULE, "VLAN Module" },
    { "MODULE_RG_ZERO_CONFIGURATION", NULL, OPT_MODULE, 
	"Universal Plug and Play" },
    { "MODULE_RG_ADVANCED_ROUTING", NULL, OPT_MODULE, 
	"Advanced Routing" },
    { "MODULE_RG_FIREWALL_AND_SECURITY", NULL, OPT_MODULE, 
	"Firewall and Security Module" },
    { "MODULE_RG_L2TP_CLIENT", NULL, OPT_MODULE, "VPN L2TP" },
    { "MODULE_RG_IPSEC", NULL, OPT_MODULE, "VPN IPSec" },
    { "MODULE_RG_PPTP", NULL, OPT_MODULE, "VPN PPTP" },
    { "MODULE_RG_FILESERVER", NULL, OPT_MODULE, "File Server" },
    { "MODULE_RG_PRINTSERVER", NULL, OPT_MODULE, "Print Server" },
    { "MODULE_RG_WLAN_AND_ADVANCED_WLAN", NULL, OPT_MODULE, 
	"WLAN and Advanced WLAN Security Module" },
    { "MODULE_RG_CABLEHOME", NULL, OPT_MODULE, "Cablehome" },
    { "MODULE_RG_VODSL", NULL, OPT_MODULE, 
	"Voice over DSL (VoDSL)" },
    { "MODULE_RG_VOIP_RV_SIP", NULL, OPT_MODULE, "VoIP SIP Stack (RADVISION)" },
    { "MODULE_RG_VOIP_RV_MGCP", NULL, OPT_MODULE, 
	"VoIP MGCP Stack (RADVISION)" },
    { "MODULE_RG_VOIP_RV_H323", NULL, OPT_MODULE, 
	"VoIP H.323 Stack (RADVISION)" },
    { "MODULE_RG_VOIP_OSIP", NULL, OPT_MODULE, "VoIP SIP Stack (oSIP)" },
    { "MODULE_RG_URL_FILTERING", NULL, OPT_MODULE, 
	"URL Filtering (Parental Control)" },
    { "MODULE_RG_QOS", NULL, OPT_MODULE, "Quality of Service" },
    { "MODULE_RG_DSLHOME", NULL, OPT_MODULE, "DSL Home" },
    { "MODULE_RG_MAIL_FILTER", NULL, OPT_MODULE, "Mail filtering (Anti-Virus)" },
    { "MODULE_RG_ADVANCED_OFFICE_SERVERS", NULL, OPT_MODULE, 
	"Advanced Office Servers" },
    { "MODULE_RG_ZERO_CONFIGURATION_NETWORKING", NULL, OPT_MODULE, 
	"Zero Configuration Networking" },

    /* Hardware device configuration */
    { "CONFIG_HW_ETH_WAN", NULL, OPT_HARDWARE | OPT_HC, "WAN Interface: ETH" },
    { "CONFIG_HW_CABLE_WAN", NULL, OPT_HARDWARE | OPT_HC,
	"WAN Interface: CABLE" },
    { "CONFIG_HW_DSL_WAN", NULL, OPT_HARDWARE | OPT_HC, "WAN Interface: DSL" },
    { "CONFIG_HW_HSS_WAN", NULL, OPT_HARDWARE | OPT_HC,
	"WAN Interface: HSS (E1/T1)" },
    { "CONFIG_HW_ETH_LAN", NULL, OPT_HARDWARE, "LAN Interface: ETH" },
    { "CONFIG_HW_ETH_EEPRO1000", NULL, OPT_HARDWARE, 
	"LAN Interface: ETH EEPRO1000" },
    { "CONFIG_HW_ETH_EEPRO100_LAN", NULL, OPT_HARDWARE, 
	"LAN Interface: ETH EEPRO100" },
    { "CONFIG_HW_ETH_LAN2", NULL, OPT_HARDWARE, "LAN Interface: ETH2" },
    { "CONFIG_HW_MOCA", NULL, OPT_HARDWARE, "Multimedia over Coax Interface" },
    { "CONFIG_HW_VDSL", NULL, OPT_HARDWARE, "WAN VDSL Interface" },
    { "CONFIG_HW_SWITCH_LAN", NULL, OPT_HARDWARE, "LAN Interface: HW Switch" },
    { "CONFIG_HW_80211B_PRISM2", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211B PRISM2" },
    { "CONFIG_HW_80211G_ISL38XX", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211G ISL38XX" },
    { "CONFIG_HW_80211G_ISL_SOFTMAC", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211G ISL SOFTMAC" },
    { "CONFIG_HW_80211G_AR531X", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211G AR531X" },
    { "CONFIG_HW_80211A_AR531X", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211A AR531X" },
    { "CONFIG_HW_80211G_BCM43XX", NULL, OPT_HARDWARE, 
	"LAN Interface: Wireless 80211G BCM43XX" },
    { "CONFIG_HW_80211G_RALINK_RT2560", NULL, OPT_HARDWARE,
	"LAN Interface: Wireless 80211G Ralink RT2560" },
    { "CONFIG_HW_80211G_RALINK_RT2561", NULL, OPT_HARDWARE,
	"LAN Interface: Wireless 80211G Ralink RT2561" },
    { "CONFIG_HW_80211N_AIRGO_AGN100", NULL, OPT_HARDWARE,
	"LAN Interface: Wireless 80211N Airgo AGN100" },
    { "CONFIG_HW_USB_RNDIS", NULL, OPT_HARDWARE, "LAN Interface: USB" },
    { "CONFIG_HW_USB_HOST_UHCI", NULL, OPT_HARDWARE, "USB Host 1.1" },
    { "CONFIG_HW_USB_HOST_OHCI", NULL, OPT_HARDWARE, "USB Host 1.1" },
    { "CONFIG_HW_USB_HOST_EHCI", NULL, OPT_HARDWARE, "USB Host 2.0" },
    { "CONFIG_HW_FIREWIRE", NULL, OPT_HARDWARE, "Firewire IEEE1394" },
    { "CONFIG_HW_FIREWIRE_STORAGE", NULL, OPT_HARDWARE, 
	"Firewire File Storage" },
    { "CONFIG_HW_USB_STORAGE", NULL, OPT_HARDWARE, "USB file Storage" },
    { "CONFIG_HW_DSP", NULL, OPT_HARDWARE, "VoIP DSP Driver"  },
    { "CONFIG_HW_KEYPAD", NULL },
    { "CONFIG_HW_PCMCIA_CARDBUS", NULL, OPT_MODULE_EXPAND },
    { "CONFIG_HW_CAMERA_USB_OV511", NULL },
    { "CONFIG_HW_CAMERA_USB_PWC", NULL },
    { "CONFIG_HW_CAMERA_USB_SPCA5XX", NULL },
    { "CONFIG_HW_EEPROM", NULL },
    { "CONFIG_HW_LEDS", NULL, OPT_HARDWARE, "LED Support"  },
    { "CONFIG_HW_BUTTONS", NULL, OPT_MODULE_EXPAND | OPT_STATIC_ON_DEVELOP },
    { "CONFIG_HW_ENCRYPTION", NULL, OPT_HARDWARE, "IPSec HW Encryption" },
    { "CONFIG_HW_CLOCK", NULL, OPT_HC },
    { "CONFIG_HW_IDE", NULL, OPT_HC },
    { "CONFIG_HW_I2C", NULL, OPT_HC },
    { "CONFIG_HW_ENV_MONITOR", NULL, OPT_HC },
    { "CONFIG_HW_ST_20190", NULL, OPT_HARDWARE | OPT_HC, "ADSL2+" },    
    { "CONFIG_RG_FLASH_ONLY_ON_BOOT", NULL, OPT_HC },
    { "CONFIG_RG_MAC_CLONING", NULL, OPT_HC },
    { "CONFIG_RG_WLAN_REPEATING", NULL, OPT_HC },
    { "CONFIG_RG_WDS_CONN_NOTIFIER", NULL, OPT_MODULE_EXPAND },

    /* Interception of HTTP traffic when Internet connection
     * was never configured or is not running */
    { "CONFIG_RG_UNCONFIGURED_WAN_INTERCEPTION", NULL, OPT_HC },
    { "CONFIG_RG_STATISTICS_CTRL_WBM", NULL, OPT_HC },    
    { "CONFIG_RG_WLAN_STA_STATISTICS_WBM", NULL, OPT_HC },    
    { "CONFIG_RG_CHECK_BAD_REBOOTS", NULL, OPT_HC },    

    /* FS types (XXX: Move all types here and rearrange) */
    { "CONFIG_RG_ROOTFS_TMPFS", NULL },
    { "CONFIG_RG_INITFS_CRAMFS", NULL },
    { "CONFIG_RG_ROOTFS_RAMDISK", NULL },
    { "CONFIG_RG_INITFS_RAMDISK", NULL },
    { "CONFIG_TMPFS", NULL, OPT_NOSTRIP },

    /* CRAMFS compression method - can be "none", "gzip", "lzma" */
    { "CONFIG_RG_CRAMFS_COMP_METHOD", NULL, OPT_STR },

    /* Kernel compression method - can be "gzip", "bzip2", lzma",
     * default is "lzma". */
    { "CONFIG_RG_KERNEL_COMP_METHOD", NULL, OPT_STR },
    { "CONFIG_RG_BZIP2_COMPRESSED_KERNEL", NULL, OPT_NOSTRIP },
    { "CONFIG_RG_GZIP_COMPRESSED_KERNEL", NULL, OPT_NOSTRIP },
    { "CONFIG_RG_LZMA_COMPRESSED_KERNEL", NULL, OPT_NOSTRIP },

    /* Entropic MoCA 2010 and 2210 */
    { "CONFIG_ENTROPIC_CLINK", NULL, OPT_MODULE_EXPAND | OPT_HC },
    { "CONFIG_ENTROPIC_EN2210", NULL, OPT_MODULE_EXPAND | OPT_HC },

    { "CONFIG_HW_SWITCH_KENDIN_KS8995M", NULL, OPT_MODULE_EXPAND | OPT_HC,
	"Kendin hardware switch" },

    { "CONFIG_HW_SWITCH_MARVELL_MV88E6083", NULL, OPT_MODULE_EXPAND | OPT_HC,
	"Marvell 8 port hardware switch" },

    { "CONFIG_TASKLET_ME_HARDER" },
    { "CONFIG_MI424WR_REV2A" },

    /* Use precompiled ulibc from toolchaion
     * Currently disabled.
     */
    { "CONFIG_RG_ULIBC_PRECOMPILED", "n", OPT_MK },
    /* Use precompiled glibc from toolchaion */
    { "CONFIG_RG_GLIBC_PRECOMPILED", NULL, OPT_MK },

    /* Use CCACHE */
    { "CONFIG_RG_CCACHE", NULL, OPT_MK },

    { "CONFIG_RG_LICENSE", NULL },
    
    /* Disables --static from LOCAL_LDFLAGS to enable valgrind */
    { "CONFIG_RG_VALGRIND_LOCAL_TARGET", NULL, OPT_MK },
    /* Check "printf" format in language at compile time (creates DEF only
     * support image!) */
    { "CONFIG_RG_LANG_TEST", NULL, OPT_MK },

    /* Component manager */
    { "CONFIG_RG_OPTION_MANAGER", NULL, OPT_HC },
    
    /* Internal configuration options, according to detected host environment.
     * These flags cannot be configured from command line
     */
    { "ENDIAN_LDFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "ENDIAN_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OS_PATH", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TOOLCHAIN_ROOT", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "I386_TARGET_MACHINE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "I386_TOOLS_PREFIX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TARGET_MACHINE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TOOLS_PREFIX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CROSS_COMPILE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "ULIBC_IN_TOOLCHAIN", NULL, OPT_INT | OPT_MK },
    { "GLIBC_IN_TOOLCHAIN", NULL, OPT_INT | OPT_MK },
    { "CC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CXX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TARGET_CXX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TARGET_CC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "REAL_GCC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CC_FOR_BUILD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CXX_FOR_BUILD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "GCC_HAS_SIZE_OPTIMIZE", NULL, OPT_INT | OPT_MK },
    { "RG_GLIBC_VERSION", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "GCC_VERSION", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "AR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "AS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "NM", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RANLIB", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "STRIP", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "SIZE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OBJCOPY", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OBJDUMP", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_AR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_LD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_AS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_NM", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_RANLIB", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_STRIP", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_SIZE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_OBJCOPY", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOST_OBJDUMP", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "YACC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "ENV", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "BASH_ENV", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "YFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "SPCC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "FLTHDR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TEXMFCNF", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TEXMF", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_INCLUDE_DIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_BIN", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_LIB", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_INCLUDE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "NET_TOOLS_MAKE_FILE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LOCAL_ADD_RG_KERNEL_FOR_TARGET", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "PATH", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "DYNAMIC_LINKER", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LDFLAT", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "PERM_STORAGE_FILES_DIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LZMAMK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "BINFRMT_FILE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "COMPRESSED_RAMDISK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "COMPRESSED_INIT_DISK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "MODFS_DISK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "AUTOCONF_H", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "PROD_LINUX_TARGET", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OS_TARGET", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HOSTCC", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CPP", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CPP_FOR_BUILD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "STATIC_MOD_DIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_LIBPTHREAD_VERSION", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "NEEDED_SYMBOLS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "COMPRESSED_DISK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "BOOTLDR_COMPRESSED_DISK", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "GENROMFS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "PROD_KERNEL_IMAGE", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_IMG", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_RMT_UPDATE_IMG", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_PROD", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "FLASH_IMG", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "BOOTLDR_IMG", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "HAVE_GC_SECTIONS", NULL, OPT_INT | OPT_MK },
    { "LINUX_ARCH_PATH", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "VX_INCLUDE_DIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "ARCH_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_CPU", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "FLASH_IMG_OFFSET", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "FLASH_IMG_REAL_OFFSET", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_LINUX_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LINUX_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "ARCH_LINUX_FLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LDFLAGS_ENVIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LOCAL_LDFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LOCAL_CFLAGS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "RG_LIB_VERSION", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LIBC_DIR_PREFIX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CFLAGS_ENVIR", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_LIB", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_GPL_LIB", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_GPL_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "OPENRG_LOCAL_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "MGT_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "MGT_LOCAL_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LANG_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "LANG_LOCAL_LDLIBS", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "TRX", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "UNITTEST_SPAWNER", NULL, OPT_INT | OPT_MK | OPT_STR },
    { "CONFIG_RG_FASTPATH_IPTV", NULL, OPT_MK | OPT_HC | OPT_MODULE_EXPAND }, 

    { NULL, NULL }
};
