INSTALL_FILES=$(addprefix $(TOPDIR)/lib/,$(INSTALL_OTHER))
INSTALL_STATIC=$(addprefix $(TOPDIR)/lib/,$(LIB_STATIC))

OTHER_TARGETS+=$(INSTALL_STATIC) $(INSTALL_FILES)

ifeq ($(strip $(CONFIG_ULIBC_SHARED)),y)
  RAMDISK_LIB_FILES=$(LIB_SHARED_FULLNAME)
  RAMDISK_LINKS+=$(LIB_SHARED_MAJORNAME) $(LIB_SHARED)
  INSTALL_SHARED+=$(addprefix $(TOPDIR)/lib/,$(LIB_SHARED_FULLNAME) \
    $(RAMDISK_LINKS))
  OTHER_TARGETS+=$(LIB_SHARED_FULLNAME) $(INSTALL_SHARED)
endif

ifdef ULIBC_IN_TOOLCHAIN
  RAMDISK_FIRST_TASKS+=link_toolchain_ulibc
endif

include $(RGMK)

link_toolchain_ulibc:
	$(RG_LN) $(TOOLS_PREFIX)/ulibc/lib/$(LIB_SHARED_FULLNAME) .

$(INSTALL_SHARED): $(LIB_SHARED_FULLNAME)
	ln -sfn $(CURDIR)/$^ $@

$(INSTALL_STATIC): $(LIB_STATIC)
	ln -sfn $(CURDIR)/$^ $@

$(INSTALL_FILES): $(INSTALL_OTHER)
	ln -sfn $(CURDIR)/$(notdir $@) $@

ramdisk::
	$(foreach l,$(RAMDISK_LINKS),$(call RAMDISK_LN_FUNC,$(CRAMFS_RUNTIME_MOUNT_POINT)/lib/$(LIB_SHARED_FULLNAME),$(RAMDISK_RW_LIB_DIR)/$l))
